--
-- 账号管理

-- local ErrorBox = require("app.component.box.ErrorBox")
-- import("app.dm.ServerDM")
-- import("app.text.ErrorText")

-- local NetErrorDlg = require("app.dialog.NetErrorDlg")
-- local APIUtils = require("app.service.APIUtils")

-- require("app.text.LoginText")

require("app.mo.LoginMO")

-- 此变量不能放在LoginMO中，LoginMO在进入后，不会重新加载，这样首次更新后，则没有此变量
HOME_SNOW_VERSION = 140  -- 场景中的雪景版本号的最大值

LoginBO = {}

-- 注册时名称的最大长度
REGISTER_NAME_MAX_LEN = 12
-- 创建角色时的最长名称
ROLE_NAME_MAX_LEN = 18

--IPV6审核地址
-- GameConfig.accountURL_ipv6 = "http://iosipv4-hf.dg.qcwan.com:9100/empire_account/account/account.do"
-- GameConfig.areaURL_ipv6 = "http://iosipv4-hf.dg.qcwan.com/serverlist_empire.json"
-- GameConfig.verifyURL_ipv6 = "http://iosipv4-hf.dg.qcwan.com/version/empire_ios_test.json"


-- local storge_file = "accountList"

--游戏服务器验证服务-check.do
-- local checkService = "/check.do"
--游戏服务器逻辑服务-logic.do
-- local logicService = "/logic.do"

--获得分区列表成功
-- local onAreaSuccess

-- 初始本地的所有账号
function LoginBO.initLocalAcounts()
	local content = readfile(LoginMO.accountsFileName)
	if content then
		local accounts = json.decode(content)
		LoginMO.setLocalAccounts(accounts)
	end
end

-- 在客户端本地中获得当前版本号
function LoginBO.initVersion()
    local version = nil
    local verFile = CACHE_DIR .. GameConfig.versionManifest  -- 先从cache中查询

    if io.exists(verFile) then
        version = CCFileUtils:sharedFileUtils():getStringFromFile(verFile)
    else
        --从初始目录读文件列表
        local cpath = CCFileUtils:sharedFileUtils():fullPathForFilename(GameConfig.versionManifest)
        
        gprint("LoginBO.initVersion 需要从初始目录读版本号", cpath)
        
        if cpath ~= GameConfig.versionManifest then
            version = CCFileUtils:sharedFileUtils():getStringFromFile(cpath)
        end
        -- gprint("LoginBO.initVersion 从初始目录读版本号文件complete")
    end

    if not version then
    	version = GameConfig.version
    end

    GameConfig.version = version
    
    gprint("[LoginBO] version:", GameConfig.version)
end

function LoginBO.initRunParam(callback)
	local function setParam(runParam)
		local p = string.split(runParam, "|")
	
		GameConfig.environment = p[1]

		if p[2] ~= nil then GameConfig.cpid = p[2] end

		gprint("[LoginBO] environment:", GameConfig.environment)
		gprint("[LoginBO] cpid:", GameConfig.cpid)

        require_ex("app.address." .. GameConfig.environment)

        gprint("[LoginBO] account url:", GameConfig.accountURL)

        if callback then callback() end
	end

	ServiceBO.getRunParam(function(p)
			setParam(p)
		end)
end

function LoginBO.initUUID(callback)
    ServiceBO.getUUID(function(uuid)
	        GameConfig.uuid = uuid

	        gprint("[LoginBO] uuid:", GameConfig.uuid)
	        if callback then callback() end
	    end)
end

function LoginBO.initGameURL()
	gprint("[LoginBO] initGameURL area:", GameConfig.areaId)
    local currentArea = LoginMO.getServerById(GameConfig.areaId)
    gdump(currentArea, "LoginUpdate.updateGameURL")

    GameConfig.gameURL = currentArea.url
    if string.sub(GameConfig.gameURL, 1, 7) ~= "http://" then
        GameConfig.gameURL = "http://" .. GameConfig.gameURL
    end

    GameConfig.gameSocketURL = currentArea.socketURL

    GameConfig.gamePort = currentArea.port

    gprint("[LoginBO] game url:", GameConfig.gameURL)
    gprint("[LoginBO] game socket url:", GameConfig.gameSocketURL)
    gprint("[LoginBO] game port:", GameConfig.gamePort)
end

-- function LoginBO.initSession(session)
--     GameConfig.session = session
--     gprint("[LoginBO] session:", GameConfig.session)
-- end

-- 判断当前是否是自家登录。如果是则显示登录框，如果不是则使用SDK登录
function LoginBO.isSelfLogin()
	if GameConfig.environment == "self_client" or GameConfig.environment == "ipay_client" or GameConfig.environment == "ios_client" or GameConfig.environment == "zty_nake_client" 
		or GameConfig.environment == "tanwan_self" or GameConfig.environment == "tygsj2_pc_client" then
		return true
	else
		return false
	end
end

-- 拉取服务器配置json
function LoginBO.asynGetServerList(callBack)
	ServiceBO.getIPAddress(function(ipAddress)
    		local function getListCallback(event)
			local wrapper = event.obj
			local content = wrapper:getData()
			local data = json.decode(content)
			gdump(data, "LoginBO.asynGetServerList")

			-- LoginMO.baseVersion_ = data.baseVersion
			-- LoginMO.serverList_ = LoginBO.filterServerList(data)


			--0 老方式  1 新方式
			if LoginMO.serverListType == 1 then
				LoginMO.serverList_ = LoginBO.filterServerListNew(data)
			else
				LoginMO.serverList_ = LoginBO.filterServerList(data)
			end


			if callBack then callBack() end
		end

	    local url
		local myDeviceIP = ipAddress
		local localVersion = LoginBO.getLocalApkVersion()
		if not myDeviceIP then myDeviceIP = "" end

		
		print("LoginMO.serverListType222:",LoginMO.serverListType)
		--0 老方式  1 新方式
		if LoginMO.serverListType == 1 then
			local newUrl = string.sub(GameConfig.areaURL,1,string.len(GameConfig.areaURL)-5)
			url = newUrl .. "_" .. LOGIN_PLATFORM_PARAM .. ".json"
		else
			url = GameConfig.areaURL
		end
		
		print("GameConfig.areaURL_NEW:",url)

		local wrapper = NetWrapper.new(getListCallback, nil, true, REQUEST_TYPE_GET, url, false)
		wrapper:sendRequest()
    	end
	)
end

--处理登录结果
local function parseLoginResult(event)
	ServiceBO.sdkLogining_ = false

	local data = nil
	if not GLOBAL_NETWORK_ON then
		data = {}
		data.recent = {1}
		data.active = 1
	else
		local wrapper = event.obj
		local doLogin = wrapper:getRequestByName("DoLogin")
		-- gdump(doLogin, "doLogin")

		data = doLogin:getData()
		gdump(data, "DoLogin data")
	end

	-- 登录返回数据出错
	if not data then
		LoginBO.clearAccount()
		return
	end

	--成功
	--身份令牌
	GameConfig.token = data.token
	GameConfig.keyId = data.keyId
	ServiceBO.coolpadStr = data.coolpadStr
	ServiceBO.ftxStr = data.ftxStr
	
	ServiceBO.userInfo = data.userInfo


	
	LoginMO.recentLogin_ = data.recent

	gprint("[LoginBO] token:", GameConfig.token)
	gprint("[LoginBO] keyId:", GameConfig.keyId)
	-- gprint("[LoginBO] recent:", GameConfig.recent)

	LoginBO.saveAccount(LoginMO.getEmail(), LoginMO.getPassword())

	--草花用户绑定
	if GameConfig.environment == "chpub_client" or GameConfig.environment == "chYh_client" then
		ServiceBO.userInfoBind(data.userInfo)
	end

	if data.userInfo and data.userInfo == "1" then
		TKGameBO.onRegister(data.keyId)
	end
	TKGameBO.onLogin(data.keyId)


	-- 根据返回状态判断是否有激活流程0未激活 1已激活
	if data.active == 0 then
		Enter.startActivate()
	else
		Enter.startArea()
	end

end

-- 处理注册结果
local function parseRegistResult(event)
	-- gprint("parseRegistResult ... ")
	local wrapper = event.obj
	local doRegister = wrapper:getRequestByName("DoRegister")

	local data = doRegister:getData()
	gdump(data, "DoRegister data")

	if not data then
		LoginBO.clearAccount()
		return
	end

	GameConfig.token = data.token
	GameConfig.keyId = data.keyId

	gprint("[LoginBO] token:", GameConfig.token)
	gprint("[LoginBO] keyId:", GameConfig.keyId)

	LoginBO.saveAccount(LoginMO.getEmail(), LoginMO.getPassword())

	-- if device.platform == "ios" or device.platform == "mac" then
	-- 	local data = {reuid = data.keyId}
	-- 	local dataStr = "json=" .. json.encode(data)
	-- 	gprint("[LoginBO] parseRegistResult device is IOS or MAC")
	-- else
	-- 	-- 根据返回状态判断是否有激活流程0未激活 1已激活
	-- 	if data.active == 0 then
	-- 		Enter.startActivate()
	-- 	else
	-- 		Enter.startArea()
	-- 	end
	-- end

	-- 根据返回状态判断是否有激活流程0未激活 1已激活
	if data.active == 0 then
		Enter.startActivate()
	else
		Enter.startArea()
	end
end

local function parseRoleLoginResult(notifyName, code, data)
	gdump(data, "[LoginBO] parseRoleLoginResult code:", code)

	Loading:getInstance():unshow()

	if handleCode(name, code, data) then return end

	if table.isexist(data, "war") and data.war == 1 then
		PartyBattleMO.isOpen = true
	else
		PartyBattleMO.isOpen = false
	end

	if table.isexist(data, "boss") and data.boss == 1 then  -- 世界BOSS是否开启
		ActivityCenterMO.isBossOpen_ = true
	else
		ActivityCenterMO.isBossOpen_ = false
	end

	if table.isexist(data, "staffing") and data.staffing == 1 then -- 编制功能是否开启
		StaffMO.isStaffOpen_ = true
	else
		StaffMO.isStaffOpen_ = false
	end

	if table.isexist(data, "fortress") and data.fortress == 1 then -- 编制功能是否开启
		FortressMO.isOpen_ = true
	else
		FortressMO.isOpen_ = false
	end
	
	if table.isexist(data, "drill") then -- 红蓝大战是是否报名
		if not ExerciseBO.data then ExerciseBO.data = {} end
		ExerciseBO.data.isEnrolled = data.drill
	end
	
	if table.isexist(data, "crossFight") then -- 跨服战是否开启
		CrossMO.isOpen_ = data.crossFight == 1
	end
	if table.isexist(data, "crossParty") then -- 跨服军团战是否开启
		CrossPartyMO.isOpen_ = data.crossParty == 1
	end
	-- 进入游戏
	Enter.startLoading()
end

--选区回调
local function parseBeginGameResult(name, code, data)
	gdump(data, "LoginBO parseBeginGameResult code: " .. code)

	if handleCode(name, code, data) then return end
	-- local data = {}
	-- if not GLOBAL_NETWORK_ON then
	-- 	data.sd = "1234kjdlfsjdk34"
	-- 	data.time = os.time()
	-- 	data.state = 2
	-- 	data.name = {}
	-- else
	-- 	local beginGame = event.obj:getRequestByName("BeginGame")
	-- 	data = beginGame:getData()
	-- 	gdump(data, "LoginBO parseBeginGameResult")
	-- end


	data.name = data.name or {}

	-- LoginBO.initSession(data.sd)
	LoginMO.roleNames_ = data.name

	if data.state == 1 or data.state == 2 then
		ManagerTimer.start(data.time)

		if data.state == 1 then -- 需要创建角色
			Loading.getInstance():unshow()
			Enter.startRole()
		elseif data.state == 2 then
			SocketWrapper.wrapSend(parseRoleLoginResult, NetRequest.new("RoleLogin"))
		end
	elseif data.state == 3 then  -- 账号被禁
		Loading.getInstance():unshow()
		Toast.show(LoginText[32])
	elseif data.state == 4 then  -- 不在白名单
		Loading.unshow()
		Toast.show(LoginText[17])
	elseif data.state == 5 then  --前往新区
		Loading.getInstance():unshow()
		Toast.show(LoginText[66])
	end
end

-- 账号登录
function LoginBO.asynAccountLogin(email_s, pas_s, doneCallback)
	local baseVer_
	if not GAME_APK_VERSION or GAME_APK_VERSION == "" then 
		baseVer_ = "1.0.0"
	else
		baseVer_ = GAME_APK_VERSION
	end
	local loginData = {
		sid = email_s .. "_" .. pas_s,
		plat = GameConfig.loginPlatform,
		version = GameConfig.version,
		baseVersion = baseVer_,
		deviceNo = GameConfig.uuid,
	}

	LoginMO.setEmail(email_s)
	LoginMO.setPassword(pas_s)

   local doLogin = NetRequest.new("DoLogin", loginData)

   local callback = doneCallback
   if not callback then callback = parseLoginResult end -- 使用默认的
    
    local wrapper = NetWrapper.new(parseLoginResult, nil, nil, nil, GameConfig.accountURL)
    wrapper:addRequest(doLogin)
    wrapper:sendRequest()
    -- wrapper:sendGetRequest()
end

-- sdk登录
function LoginBO.asynSdkLogin(sdkToken)
	ServiceBO.getIPAddress(function(ipAddress)
		    local url
    		local myDeviceIP = ipAddress
			local localVersion = LoginBO.getLocalApkVersion()
			if not myDeviceIP then myDeviceIP = "" end
			-- if (device.platform == "ios" or device.platform == "mac") and localVersion >= 121 and myDeviceIP:find(":") and GameConfig.accountURL_ipv6 then
			-- 	url = GameConfig.accountURL_ipv6
			-- else
				url = GameConfig.accountURL
			-- end
			ServiceBO.sdkLogining_ = true
			gprint("LoginBO.asynSdkLogin", sdkToken)
			GameConfig.sdkLoginToken = sdkToken
			local baseVer_
			if not GAME_APK_VERSION or GAME_APK_VERSION == "" then 
				baseVer_ = "1.0.0"
			else
				baseVer_ = GAME_APK_VERSION
			end
			local loginData = {
					sid = sdkToken,
					plat = LOGIN_PLATFORM_PARAM,
					version = GameConfig.version,
					baseVersion = baseVer_,
					deviceNo = GameConfig.uuid
				}
			gdump(loginData, "LoginBO.asynSdkLogin data")

			local doLogin = NetRequest.new("DoLogin", loginData)

		    local wrapper = NetWrapper.new(parseLoginResult, nil, nil, nil, url)
		    wrapper:addRequest(doLogin)
		    wrapper:sendRequest()
    	end
	)	
end

-- 游戏中的重新登录, 注意:必须是在游戏中，如果没有成功登录过游戏，不要调用
function LoginBO.asynReLogin(doneCallback)
	local function doneDoLogin(event)
		local wrapper = event.obj
		local doLogin = wrapper:getRequestByName("DoLogin")
		-- gdump(doLogin, "doLogin")

		data = doLogin:getData()
		gdump(data, "DoLogin data")

		--身份令牌
		GameConfig.token = data.token
		GameConfig.keyId = data.keyId

		if doneCallback then doneCallback() end
	end

	local sid = ""
	if LoginBO.isSelfLogin() then sid = LoginMO.getEmail() .. "_" .. LoginMO.getPassword()
	else sid = GameConfig.sdkLoginToken end

	local baseVer_
	if not GAME_APK_VERSION or GAME_APK_VERSION == "" then 
		baseVer_ = "1.0.0"
	else
		baseVer_ = GAME_APK_VERSION
	end

	local doLogin = NetRequest.new("DoLogin", {sid = sid, plat = LOGIN_PLATFORM_PARAM, version = GameConfig.version, baseVersion = baseVer_, deviceNo = GameConfig.uuid})
    local wrapper = NetWrapper.new(doneDoLogin, nil, nil, nil, GameConfig.accountURL)
    wrapper:addRequest(doLogin)
    wrapper:sendRequest()
    -- wrapper:sendGetRequest()
end

--账号注册
function LoginBO.asynRegistAccount(email_s, pas_s)
	local baseVer_
	if not GAME_APK_VERSION or GAME_APK_VERSION == "" then 
		baseVer_ = "1.0.0"
	else
		baseVer_ = GAME_APK_VERSION
	end
	registerData = {
		plat = GameConfig.loginPlatform,
		version = GameConfig.version,
		baseVersion = baseVer_,
		deviceNo = GameConfig.uuid,
		accountId = email_s,
		passwd = pas_s
	}

	LoginMO.setEmail(email_s)
	LoginMO.setPassword(pas_s)

    local doRegister = NetRequest.new("DoRegister", registerData)

    local wrapper = NetWrapper.new(parseRegistResult, nil, nil, nil, GameConfig.accountURL)
    wrapper:addRequest(doRegister)
    wrapper:sendRequest()
    -- wrapper:sendGetRequest()
end

-- 账号激活
function LoginBO.asynAccountActivate(doneCallback, activateCode)
	local function parseActivate()
		if doneCallback then doneCallback() end
	end

	-- if true then
	-- 	parseActivate()
	-- 	return
	-- end

	local doActive = NetRequest.new("DoActive", {keyId = GameConfig.keyId, activeCode = activeCode})
    local wrapper = NetWrapper.new(parseRegistResult, nil, nil, nil, GameConfig.accountURL)
    wrapper:addRequest(doActive)
    wrapper:sendRequest()
end

--清除账号
function LoginBO.clearAccount()
	writefile(LoginMO.accountsFileName, "")
end

-- 保存账号
function LoginBO.saveAccount(email, password)
	if email and password then
		local accounts = LoginMO.getLocalAccounts()

		local index = LoginBO.getLocalAccountIndex(email)
		if index > 0 then  -- 如果已经存在，则先移除
			table.remove(accounts, index)
		end

		local account = {accountId = email, passwd = password}

		table.insert(accounts, 1, account)

		writefile(LoginMO.accountsFileName, json.encode(accounts))
	end
end

-- 获得账号account在本地保存的位置索引
function LoginBO.getLocalAccountIndex(accountId)
	local accounts = LoginMO.getLocalAccounts()

	for index = 1, #accounts do
		if accounts[index].accountId == accountId then
			return index
		end
	end
	return -1
end


--获得存储的账号
-- function LoginBO.getAccount()
-- 	local path = CCFileUtils:sharedFileUtils():getCachePath() .. storge_file
-- 	if io.exists(path) then
-- 		local contents = io.readfile(path)
-- 		LoginBO.loginHis = json.decode(contents)
-- 		-- dump(LoginBO.loginHis)
-- 		return LoginBO.loginHis
-- 	end
-- end

-- function LoginBO.writefile()
-- 	local path = CCFileUtils:sharedFileUtils():getCachePath() .. storge_file
-- 	local contents = json.encode(LoginBO.loginHis)
-- 	return io.writefile(path, contents, "w+b")
-- end

-- 选区
function LoginBO.asynBeginGame(doneCallback)
	local param = {
		serverId = GameConfig.areaId,
		keyId = GameConfig.keyId,
		token = GameConfig.token,
		deviceNo = GameConfig.uuid,
		curVersion = GameConfig.version
	}

	-- gdump(param, "BeginGame")
	local callback = doneCallback
	if not callback then callback = parseBeginGameResult end -- 使用默认的回调

	SocketWrapper.wrapSend(callback, NetRequest.new("BeginGame", param))
end

-- 创建角色时，获得角色名称
function LoginBO.asynGetRoleNames(doneCallback)
	local function parseGetNames(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "LoginBO asynGetRoleNames")

			LoginMO.roleNames_ = data.name
		end

		if doneCallback then doneCallback() end
	end

	SocketWrapper.wrapSend(parseGetNames, NetRequest.new("GetNames", param))
end

-- 创建角色
function LoginBO.asynCreateRole(doneCallback, nick, portrait, sex)
	local function parseCreateRole(name, code, data)
		if not handleCode(name, code, data) then
			SocketWrapper.wrapSend(parseRoleLoginResult, NetRequest.new("RoleLogin"))

			--TK统计
	    	TKGameBO.onCreateRole(nick)


			--创建角色提交数据
			ServiceBO.creatRole(nick)
			
		else
			if doneCallback then doneCallback(false) end
		end
	end

	-- gprint("LoginBO asynCreateRole")
	SocketWrapper.wrapSend(parseCreateRole, NetRequest.new("CreateRole", {nick = nick, portrait = portrait, sex = sex}))
end


function LoginBO.isInPlat(plats)
	for index=1,#plats do
		local plat = plats[index]
		if plat == LOGIN_PLATFORM_PARAM then
			return true
		end
	end
	return false
end


function LoginBO.filterServerList(data)
	--新版规则(根据control字段，判断当前渠道是否显示专服列表)
	function getControlList(data)
		local controlList = nil
		if data.control then
			controlList = {}
			for index=1,#data.control do
				local controlData = data.control[index]
				if controlData.plat then
					if LoginBO.isInPlat(controlData.plat) then
						if controlData.allowMin and controlData.allowMax then
							for j=controlData.allowMin, controlData.allowMax do
								controlList[#controlList + 1] = j
							end
						else
							if controlData.allowMin then
								for j=controlData.allowMin, #data.list do
									controlList[#controlList + 1] = j
								end
							elseif controlData.allowMax then
								for j=1, controlData.allowMax do
									controlList[#controlList + 1] = j
								end
							end
						end
						if controlData.allow then
							for j=1,#controlData.allow do
								controlList[#controlList + 1] = controlData.allow[j]
							end
						end
					end
				else
					-- Toast.show("JSONError:not have plat")
				end
			end
		end
		return controlList
	end

	local list = data.list
	local servers = {}
	local controlList = getControlList(data)

	
	--IOS审核阶段只能看到ID为 999 的审核服
	--android审核阶段只能看到ID为1的审核服
	if GameConfig.enableCode == false or GameConfig.androidTest == true then
		if GameConfig.enableCode == false then
			for index=1,#list do
				server = list[index]
				if server.id == 9999 or server.id == 123456789 then
					servers[#servers + 1] = server
				end
			end
		elseif GameConfig.androidTest == true then
			for index=1,#list do
				server = list[index]
				if server.id == 1 then
					servers[#servers + 1] = server
				end
			end
		end
	else 
		if controlList and #controlList > 0 then
			for index=1,#list do
				server = list[index]
				for j=1,#controlList do
					local serverId = controlList[j]
					if serverId == server.id then
						if GameConfig.skipStop or server.show == 1 then
							servers[#servers + 1] = server
						end
					end
				end
			end
		else
			for index=1,#list do
				server = list[index]
				if not server.plat or (server.plat and LoginBO.isInPlat(server.plat)) then
					if GameConfig.skipStop or server.show == 1 then
						servers[#servers + 1] = server
					end
				end
			end
		end
	end


	if GameConfig.environment == "qzBwzxHw_client" or GameConfig.environment == "qzBwzxBaidu_client" or GameConfig.environment == "qzBwzxMeizu_client" 
		or GameConfig.environment == "qzBwzxGionee_client" or GameConfig.environment == "qzBwzxXiaomi_client" or GameConfig.environment == "qzBwzxOppo_client"
		or GameConfig.environment == "qzBwzx360_client" or GameConfig.environment == "qzBwzxLenovo_client" or GameConfig.environment == "qzBwzxQuick_client" 
		or GameConfig.environment == "qzBwzxQuick02_client" or GameConfig.environment == "qztygsjQuick_client" or GameConfig.environment == "qzBwzxQ_appstore" then
		
		for index=1, #servers do
			local server = servers[index]
			if server.name1 then
				server.name = server.name1
			end 
		end
	end


	--排序
	--排序规则，new < hot < id
	local function sortFun(a,b)
		if a.new == b.new then
			if a.hot == b.hot then
				return a.id < b.id
			else
				return a.hot < b.hot
			end
		else
			return a.new < b.new
		end
	end
	table.sort(servers,sortFun)
	return servers
end


function LoginBO.filterServerListNew(data)

	local list = data.list
	local servers = {}

	--IOS审核阶段只能看到review为 1 的审核服
	if GameConfig.enableCode == false or GameConfig.androidTest == true then
		if GameConfig.enableCode == false then
			for index=1,#list do
				server = list[index]
				if server.review == 1 then
					servers[#servers + 1] = server
				end
			end

		elseif GameConfig.androidTest == true then
			for index=1,#list do
				server = list[index]
				if server.id == 1 then
					servers[#servers + 1] = server
				end
			end
		end 
	else
		for index=1,#list do
			server = list[index]
			--自有渠道显示所有区服
			if GameConfig.environment == "self_client" then
				servers[#servers + 1] = server
			else
				--非自有渠道显示show为1的游戏服（除去IOS审核服）
				if server.review ~= 1 and server.show == 1 then
					servers[#servers + 1] = server
				end
			end
		end
	end

	if GameConfig.environment == "qzBwzxHw_client" or GameConfig.environment == "qzBwzxBaidu_client" or GameConfig.environment == "qzBwzxMeizu_client" 
		or GameConfig.environment == "qzBwzxGionee_client" or GameConfig.environment == "qzBwzxXiaomi_client" or GameConfig.environment == "qzBwzxOppo_client"
		or GameConfig.environment == "qzBwzx360_client" or GameConfig.environment == "qzBwzxLenovo_client" or GameConfig.environment == "qzBwzxQuick_client" 
		or GameConfig.environment == "qzBwzxQuick02_client" or GameConfig.environment == "qztygsjQuick_client" or GameConfig.environment == "qzBwzxQ_appstore" then
		
		for index=1, #servers do
			local server = servers[index]
			if server.name1 then
				server.name = server.name1
			end 
		end
	end


	--排序
	--排序规则，new < hot < id
	local function sortFun(a,b)
		if a.new == b.new then
			if a.hot == b.hot then
				return a.id < b.id
			else
				return a.hot < b.hot
			end
		else
			return a.new < b.new
		end
	end
	table.sort(servers,sortFun)
	return servers
end

function LoginBO.getNewOpenServerIdx()
	-- local idx = 1
	-- for index=1,#LoginMO.serverList_ do
	-- 	local server = LoginMO.serverList_[index]
	-- 	if server.id > LoginMO.serverList_[idx].id and (not server.stop or server.stop == 0) then
	-- 		idx = index
	-- 	end
	-- end
	-- return idx

	local serverList = clone(LoginMO.serverList_)

	--过滤掉维护状态的服务器
	local serverList_ = {}
	for index=1,#serverList do
		local server = serverList[index]
		if not server.stop or server.stop == 0 then
			serverList_[#serverList_ + 1] = server
		end
	end

	--排序规则，new > hot > id
	local function sortFun(a,b)
		if a.new == b.new then
			if a.hot == b.hot then
				return a.id > b.id
			else
				return a.hot > b.hot
			end
		else
			return a.new > b.new
		end
	end
	
	gdump(LoginMO.serverList_,"LoginMO.serverList_====")
	table.sort(serverList_,sortFun)
	gdump(serverList_,"serverList_====")
	if #serverList_ >  0 then
		return serverList_[1].id
	else
		return LoginMO.serverList_[1].id
	end
end

-- serverId的服务器上是否有玩家的角色
function LoginBO.hasRoleInServer(serverId)
	for index = 1, #LoginMO.recentLogin_ do
		if LoginMO.recentLogin_[index] == serverId then
			return true
		end
	end
	return false
end

-- 拉取服务器APK的version信息
function LoginBO.asynGetServerApkVersion(callBack)
	local function getVersionCallback(event)
		local wrapper = event.obj
		local content = wrapper:getData()
		gprint("content",content)
		local data = json.decode(content)
		gdump(data, "LoginBO.asynGetServerApkVersion")
		if callBack then callBack(data) end
	end

    local wrapper = NetWrapper.new(getVersionCallback, nil, true, REQUEST_TYPE_GET, GameConfig.versionURL, false, UpdateText[22])
    wrapper:sendRequest()
end

function LoginBO.getLocalApkVersion()
	if not GAME_APK_VERSION or GAME_APK_VERSION == "" then return 100 end

	local localVer = string.split(GAME_APK_VERSION, ".")
	local localVer1 = ""
    for i = 1, #localVer do
        localVer1 = localVer1 .. localVer[i]
    end
    localVer1 = tonumber(localVer1)

    -- gprint("LoginBO.getLocalApkVersion =====:",localVer1)
    return localVer1
end

--判断是否需要整包更新
function LoginBO.needUpdateApk()
	-- if GameConfig.environment == "self_client" then return nil end
	if device.platform == "ios" then return nil end

	if not GameConfig.versionURL or GameConfig.versionURL == "" then return nil end
	if not GAME_APK_VERSION or GAME_APK_VERSION == "" then return nil end

	local localVer = string.split(GAME_APK_VERSION, ".")
	local localVer1 = ""
    for i = 1, #localVer do
        localVer1 = localVer1 .. localVer[i]
    end
    localVer1 = tonumber(localVer1)

    gprint("localVer1=====:",localVer1)
    if localVer1 < 200 then return nil end
    return true
end



--获取整包更新信息
function LoginBO.getApkUpdateData(callBack)
	--获取服务器APK的version信息
	LoginBO.asynGetServerApkVersion(function(data)
		local versionList = data.list
		
		print("LoginMO.serverListType000",LoginMO.serverListType)
		if data.serverlistType then
			LoginMO.serverListType = data.serverlistType
		end
		print("LoginMO.serverListType111",LoginMO.serverListType)
		
		gdump(versionList, "versionList")
		if not versionList then 
			--版本配置文件无法获取
			NetErrorDialog.getInstance():show({msg = UpdateText[17], code = nil}, function() LoginBO.getApkUpdateData(callBack) end)
			return 
		end

		--获得当前APK的versionCode和包名
	    ServiceBO.getPackageInfo(function(packageInfo)
	    	   gprint("ServiceBO.getPackageInfo")
	    	   --获得包体的包名和versionCode
	    	   local info = string.split(packageInfo, "|")
	    	   local apk_packageName = info[1]
		       local apk_versionCode = tonumber(info[2])

		       gprint("apk_packageName:" .. apk_packageName)
		       gprint("apk_versionCode:" .. apk_versionCode)
		       --根据包名取得版本信息
		       local versionData = LoginBO.getVersionDataByPackageName(versionList,apk_packageName)
		       if not versionData then Enter.startUpdate() gprint("========not need update") return end

		       --版本号无法获取
	       		if not versionData.versionCode then
	       			NetErrorDialog.getInstance():show({msg = UpdateText[23], code = nil}, function() LoginBO.getApkUpdateData(callBack) end)
					return  
	       		end
		       gprint("==============apk version compare===================")
		       gprint(apk_packageName,apk_versionCode)
		       gprint("local_versionCode:" .. apk_versionCode,"server_versionCode:"..versionData.versionCode)
		       gprint("==============apk version compare===================")
		       if apk_versionCode < versionData.versionCode then
		       		--版本下载地址无法获取
		       		if not versionData.url then
		       			NetErrorDialog.getInstance():show({msg = UpdateText[18], code = nil}, function() LoginBO.getApkUpdateData(callBack) end)
						return  
		       		end
		       		--需要更新
		       		NetErrorDialog.getInstance():show({msg = UpdateText[21], code = nil}, function() callBack(versionData.url) end)
		       	else
		       		Enter.startUpdate()
		       end
		    end)
		end)

end

function LoginBO.getVersionDataByPackageName(versionList,packageName)
	for index=1,#versionList do
		local versionData = versionList[index]
		if versionData.packageName == packageName then
			return versionData
		end
	end
	return nil
end

function LoginBO.getLoadingBg()
	local bg
    -- if GameConfig.environment == "anfan_client" then
    --     bg = display.newSprite("zLoginBg/bg_login_1.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_muzhi" then
    --     bg = display.newSprite("zLoginBg/bg_login_2.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_chpub" or GameConfig.environment == "chpub_client" 
    -- 		or GameConfig.environment == "chYh_client" then
    --     bg = display.newSprite("zLoginBg/bg_login_tencent_chpub.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_anfan" or GameConfig.environment == "anfanKoudai_client" then
    --     bg = display.newSprite("zLoginBg/bg_login_tencent_anfan.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_anfan_hj3" then
    --     bg = display.newSprite("zLoginBg/bg_login_tencent_anfanhj3.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_anfan_fktk" then
    --     bg = display.newSprite("zLoginBg/bg_login_tencent_anfanfktk.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_muzhi_sjdz" then
    --     bg = display.newSprite("zLoginBg/bg_login_tencent_sjdz.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "baidu_client" or GameConfig.environment == "anzhi_client" 
    -- 		or GameConfig.environment == "sogou_client" or GameConfig.environment == "n_uc_client" 
    -- 		or GameConfig.environment == "37wan_client" or GameConfig.environment == "downjoy_client" 
    -- 		or GameConfig.environment == "mzw_client"
    -- 		or GameConfig.environment == "meizu_client" or GameConfig.environment == "pyw_client"
    -- 		or GameConfig.environment == "jrtt_client" or GameConfig.environment == "nhdz_client"
    -- 		or GameConfig.environment == "pptv_client" or GameConfig.environment == "ttyy_client"
    -- 		or GameConfig.environment == "kaopu_client" or GameConfig.environment == "haima_client" 
    -- 		or GameConfig.environment == "tencent_muzhi_ly" or GameConfig.environment == "huashuo_client" 
    -- 		or GameConfig.environment == "zhuoyou_client" or GameConfig.environment == "yyh_client" 
    -- 		or GameConfig.environment == "qihoo360_client" or GameConfig.environment == "wdj_client" then
    -- 	bg = display.newSprite("zLoginBg/bg_login_ly.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "weiuu_client" then
    -- 	bg = display.newSprite("zLoginBg/bg_login_ly_weiuu.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "tencent_muzhi_hd" then
    -- 	bg = display.newSprite("zLoginBg/bg_login_hd.jpg", display.cx, display.cy)
    -- elseif GameConfig.environment == "ch_appstore" then
    -- 	bg = display.newSprite("zLoginBg/bg_login_ios.jpg", display.cx, display.cy)
    -- else
    local localVersion = LoginBO.getLocalApkVersion() 
    -- if GameConfig.environment == "anfanDgwm_client" or GameConfig.environment == "zhuayouDgwm_client" 
    if GameConfig.environment == "tencent_dgwm" or GameConfig.environment == "u8_dgwm" 
    	or GameConfig.environment == "ucDgwm_client" or GameConfig.environment == "afDgwm_appstore" 
    	or GameConfig.environment == "letv_dgwm" or GameConfig.environment == "afAz_dgwm" then
    	bg = display.newSprite("zLoginBg/bg_login_dgwm.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhi_zzsd" or GameConfig.environment == "muzhizzsd_appstore" 
    	or GameConfig.environment == "muzhi_zzsd001" or GameConfig.environment == "muzhi_zzsd002"
    	or GameConfig.environment == "muzhi_zzsd003" or GameConfig.environment == "muzhi_zzsd004"
    	or GameConfig.environment == "muzhi_zzsd005" then
    	bg = display.newSprite("zLoginBg/bg_login_zzsd.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "chlmzhg_appstore" or GameConfig.environment == "caohua_client"then
    	bg = display.newSprite("zLoginBg/bg_login_lmzhg.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanWmjq_appstore" or GameConfig.environment == "twzf_client" 
    	or GameConfig.environment == "tanwan_self" then
    	bg = display.newSprite("zLoginBg/bg_login_wmjq.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanQmzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_qmzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanLmwm_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmwm.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "chdgsdzzwj_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_zzwj.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "chlmfxol_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmfx.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "chlmqmzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmqmzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "chlmzzol_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanDgsd_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_tanwanDgsd.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanDgfy_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_tanwanDgfy.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgfx9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgfx9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgwc9377_appstore" or GameConfig.environment == "dgwc93771_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgwc9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "zfz9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_zfz9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "af9377_client" then
    	bg = display.newSprite("zLoginBg/bg_login_wcjq.png", display.cx, display.cy)
    elseif GameConfig.environment == "yhlz9377_client" then
    	bg = display.newSprite("zLoginBg/bg_login_yhlz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afdmDgfy_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afdm_dgfy.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afdmlmzfz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afdm_lmzfz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanDgsd2_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_tanwanDgsd2.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "lmzfz9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmzfz9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "lmfx9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmfx9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "lmscjq9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmscjq9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afDwfz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dwfz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "game350_client" then
    	bg = display.newSprite("zLoginBg/bg_login_dgwc.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "huaweiDgwm_client" or GameConfig.environment == "lenovoDgwm_client"
     	or GameConfig.environment == "oppo_dgwm" or GameConfig.environment == "vivo_dgwm"
     	or GameConfig.environment == "coolpad_dgwm" or GameConfig.environment == "mz_dgwm"
     	or GameConfig.environment == "mi_dgwm" then
    	if localVersion < 270 then
    		bg = display.newSprite("zLoginBg/bg_login_dgwm.jpg", display.cx, display.cy)
    	else
    		bg = display.newSprite("zLoginBg/bg_login.jpg", display.cx, display.cy)
    	end
    elseif GameConfig.environment == "dybDgfz_appstore" or GameConfig.environment == "dybDgfz1_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgfz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dybZzyry_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_zzyry.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "anfanDgwm_client" or GameConfig.environment == "zhuayouDgwm_client"
    	or GameConfig.environment == "anfan_client" then
    	bg = display.newSprite("zLoginBg/bg_login_anfan.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgct9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgct9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgct93771_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgct93771.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "lmzz9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmzz9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "lmzz93771_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmzz93771.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgjq9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgjq9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgwm9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgwm9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanLwzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_tanwanLwzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgzz9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dgzz9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanLmjq_appstore" or GameConfig.environment == "tanwanDgjq_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_lmjq.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dwsj9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dwsj9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "tanwanDwwm_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_tanwanDwwm.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afDgry_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_afDgry.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afDgwmba_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_afDgwmba.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afYiwanWzfx_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_afYiwanWzfx.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgfxlmdj9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_dgfxlmdj9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "wclmsd9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_wclmsd9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgzzfxlm9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_dgzzfxlm9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dwlmsdfx9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_dwlmsdfx9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "lmdgfxsd9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_lmdgfxsd9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afDgzfz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afDgzfz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afDgwmol_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afDgwmol.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "af31Lmsd_appstore" then
    	bg = display.newSprite("zLoginBg/bg_af31Lmsd.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "af31Dwsd_appstore" then
    	bg = display.newSprite("zLoginBg/bg_af31Dwsd.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhiqmzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_muzhiqmzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhidgtyz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_muzhidgtyz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhidgby_appstore" then
    	bg = display.newSprite("zLoginBg/bg_muzhidgby.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afQwDdg_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afQwDdg.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhilmdgsd_appstore" then
    	bg = display.newSprite("zLoginBg/bg_muzhilmdgsd.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "af31Dgzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_af31Dgzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "qwan_client" then
    	bg = display.newSprite("zLoginBg/bg_login_qwan.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "qianzhiYijie_client" or GameConfig.environment == "qianzhiGuopan_client" or GameConfig.environment == "qianzhiXiaoqi_client" then
    	bg = display.newSprite("zLoginBg/login_yxbzdgfz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "jq_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_jq.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhidglmfx_appstore" then
    	bg = display.newSprite("zLoginBg/bg_login_dglmfx.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afQwDgdry_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afQwDgdry.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "jqDgjq_appstore" then
    	bg = display.newSprite("zLoginBg/bg_jqDgjq.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "jqDgyz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_jqDgyz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "qzDgsdlzzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_qzDgsdlzzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "qzDgzbol_appstore" then
    	bg = display.newSprite("zLoginBg/bg_qzDgzbol.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "qzZzycx_appstore" then
    	bg = display.newSprite("zLoginBg/bg_qzZzycx.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afBqsd_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afBqsd.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afCbzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afCbzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "zsDgyz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_zsDgyz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "zsDgzb_appstore" then
    	bg = display.newSprite("zLoginBg/bg_zsDgzb.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "zsDgzf_appstore" then
    	bg = display.newSprite("zLoginBg/bg_zsDgzf.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "zsDgzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_zsDgzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "dgwmNew9377_appstore" then
    	bg = display.newSprite("zLoginBg/bg_dgwmNew9377.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhiDgzzsd_appstore" or GameConfig.environment == "muzhiu8_client" then
    	bg = display.newSprite("zLoginBg/bg_dgzbtx.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "af_appstore" or GameConfig.environment == "anfanDgzfz_client" 
    	or GameConfig.environment == "anfanDgzfzx_client" then
    	bg = display.newSprite("zLoginBg/bg_zgzfz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "qzBwzxHw_client" or GameConfig.environment == "qzBwzxBaidu_client" or GameConfig.environment == "qzBwzxMeizu_client" 
		or GameConfig.environment == "qzBwzxGionee_client" or GameConfig.environment == "qzBwzxXiaomi_client" or GameConfig.environment == "qzBwzxOppo_client"
		or GameConfig.environment == "qzBwzx360_client" or GameConfig.environment == "qzBwzxLenovo_client" or GameConfig.environment == "qzBwzxQuick_client" 
		or GameConfig.environment == "qzBwzxQuick02_client"  or GameConfig.environment == "qzBwzxQ_appstore" then
    	bg = display.newSprite("zLoginBg/bg_qzBwzxHw.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhi_dgsm" or GameConfig.environment == "muzhiDgsm_appstore" then
    	bg = display.newSprite("zLoginBg/bg_mzdgsm.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "afDgqmzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_afDgqmzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhiCbzz_appstore" then
    	bg = display.newSprite("zLoginBg/bg_muzhiCbzz.jpg", display.cx, display.cy)
    elseif GameConfig.environment == "muzhiDgxx_appstore" then
    	bg = display.newSprite("zLoginBg/bg_muzhiDgxx.jpg", display.cx, display.cy)
   	elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
   		bg = display.newSprite("zLoginBg/bg_muzhiDgqmzz.jpg", display.cx, display.cy)
   	elseif GameConfig.environment == "afdgwy_client" then
		bg = display.newSprite("zLoginBg/bg_afdgwy.jpg", display.cx, display.cy)
	elseif GameConfig.environment == "tygsj2_pc_client" or GameConfig.environment == "qztygsjQuick_client" then
		bg = display.newSprite("zLoginBg/bg_tygsj.jpg", display.cx, display.cy)
    else
    	bg = display.newSprite("zLoginBg/bg_login.jpg", display.cx, display.cy)
    end
        
    -- end

    return bg
end

--充值和创建角色黑名单地址
LoginBO.blackListURL = "http://mz_appstore.tank.hundredcent.com/recharge_black.json"

--是否能够充值和创建角色
function LoginBO.enableRecharge()
	local enable = true
	if LoginMO.blackList and #LoginMO.blackList > 0 then
		for index=1,#LoginMO.blackList do
			local plat = LoginMO.blackList[index]
			gprint(plat,LOGIN_PLATFORM_PARAM)
			if plat == LOGIN_PLATFORM_PARAM then
				enable = false
				break
			end
		end
	end
	gprint(enable,"enable===")
	return enable
end

--拉取充值和创建角色的黑名单
function LoginBO.getRechargeBlack(callBack)
	local function getListCallback(event)
		local wrapper = event.obj
		local content = wrapper:getData()
		local data = json.decode(content)
		gdump(data, "LoginBO.asynGetBlackList")
		if data and data.blackList then
			LoginMO.blackList = data.blackList
		end
		if callBack then callBack() end
	end

    local wrapper = NetWrapper.new(getListCallback, nil, true, REQUEST_TYPE_GET, LoginBO.blackListURL, false)
    wrapper:sendRequest()
end

function LoginBO.checkNickName(nick)
    local function isOk(string)
        local ch = string.byte(string, 1)

        if ch < 0 then ch = ch + 256 end

        if ch >= 228 and ch <= 233 then  -- 中文
            return true
        elseif ch == 227 then
            local ch2 = string.byte(string, 2)
            local ch3 = string.byte(string, 3)

            if ch2 == 128 and ch3 == 130 then  -- "。" (0x3002)
                return true
            else
                return false
            end
        elseif ch <= 127 then
            if ch >= 40 and ch <= 126 then
                return true
            end
        else
            return false
        end
    end

    local strTab = stringToChar_(nick)
    -- dump(strTab, "checkNick 1111111111111")
    if not strTab then return false end

    for index = 1, #strTab do
        local content = strTab[index]
        if not isOk(content) then
            return false
        end
    end
    return true
end

function LoginBO.enableCode(callBack)
	GameConfig.enableCode = true
	if not GameConfig.verifyURL then callBack(true)  return end
	if device.platform == "android" then
		callBack(true)
	elseif device.platform == "ios" or device.platform == "mac" then
		LoginBO.asynGetIosTest(function(data)
				gdump(data,"LoginBO.asynGetIosTest")
				if data.serverlistType then
					LoginMO.serverListType = data.serverlistType
				end
				local enable_ = true
				local localVersion = LoginBO.getLocalApkVersion() 
				if data.list then
					for index=1,#data.list do
						local dd = data.list[index]
						--渠道相同，版本号相同
						if dd.plat == GameConfig.environment and localVersion == dd.version then
							enable_ = false
							GameConfig.enableCode = false
							break
						end
					end
				end
				if GameConfig.environment == "dgfx9377_appstore" or GameConfig.environment == "dgwc9377_appstore" or GameConfig.environment == "zfz9377_appstore" 
					or GameConfig.environment == "lmzfz9377_appstore"  or GameConfig.environment == "lmfx9377_appstore" or GameConfig.environment == "lmscjq9377_appstore" 
					or GameConfig.environment == "dgct9377_appstore" or GameConfig.environment == "lmzz9377_appstore" or GameConfig.environment == "dgjq9377_appstore"
					or GameConfig.environment == "dgwm9377_appstore" or GameConfig.environment == "dgzz9377_appstore" or GameConfig.environment == "lmzz93771_appstore" 
					or GameConfig.environment == "dwsj9377_appstore" or GameConfig.environment == "dgct93771_appstore" or GameConfig.environment == "dgwc93771_appstore" 
					or GameConfig.environment == "dgfxlmdj9377_appstore" or GameConfig.environment == "wclmsd9377_appstore" or GameConfig.environment == "dgzzfxlm9377_appstore" 
					or GameConfig.environment == "dwlmsdfx9377_appstore" or GameConfig.environment == "lmdgfxsd9377_appstore" 
					or GameConfig.environment == "dgwmNew9377_appstore" then
					ServiceBO.iosVertifyStatus()
				end
				callBack(enable_)
			end
		)
	end
end

function LoginBO.asynGetIosTest(callBack)
    --判断网络环境是否IPV6
    ServiceBO.getIPAddress(function(ipAddress)
    		local function getIosTestCallback(event)
		        local wrapper = event.obj
		        local content = wrapper:getData()
		        gprint("content",content)
		        local data = json.decode(content)
		        if callBack then callBack(data) end
		    end
		    local url
    		local myDeviceIP = ipAddress
			local localVersion = LoginBO.getLocalApkVersion()
			if not myDeviceIP then myDeviceIP = "" end
			-- if (device.platform == "ios" or device.platform == "mac") and localVersion >= 121 and myDeviceIP:find(":") and GameConfig.verifyURL_ipv6 then
			-- 	url = GameConfig.verifyURL_ipv6
			-- else
				url = GameConfig.verifyURL
			-- end
			local wrapper = NetWrapper.new(getIosTestCallback, nil, true, REQUEST_TYPE_GET, url, false)
    		wrapper:sendRequest()
    	end
	)
end


function LoginBO.parseSdkDoLogin(param)
	local data = nil
    data = json.decode(param)

    -- 登录返回数据出错
    if not data then
        LoginBO.clearAccount()
        return
    end

    gdump(param,"LoginBO.parseSdkDoLogin...param")
    --成功
    --身份令牌
    GameConfig.token = data.token
    GameConfig.keyId = data.keyId
    
    LoginMO.recentLogin_ = data.recent


    if data.userInfo and data.userInfo == "1" then
        TKGameBO.onRegister(data.keyId)
    end
    TKGameBO.onLogin(data.keyId)

    Enter.startArea()

end

function LoginBO.apkisTest(callback)
	if not GameConfig.apkTest or GameConfig.environment ~= "twzf_client" then 
		callback(false) 
		return 
	end
	--获取服务器APK的version信息
	LoginBO.asynGetApkTestStatus(function(data)
		local versionList = data.list
		gdump(versionList, "versionList")
		if not versionList then 
			callback(false) 
			return 
		end

		--获得当前APK的versionCode和包名
	    ServiceBO.getPackageInfo(function(packageInfo)
	    	   gprint("ServiceBO.getPackageInfo")
	    	   --获得包体的包名和versionCode
	    	   local info = string.split(packageInfo, "|")
	    	   local apk_packageName = info[1]
		       local apk_versionCode = tonumber(info[2])

		       print("apk_packageName:" .. apk_packageName)
		       print("apk_versionCode:" .. apk_versionCode)
		       --根据包名取得版本信息
		       local versionData = LoginBO.getVersionDataByPackageName(versionList,apk_packageName)
		       if not versionData then 
		       		callback(false) 
					return 
		       end

		       --版本号无法获取
	       		if not versionData.versionCode then
					callback(false) 
					return 
	       		end
		       gprint("==============apk version compare===================")
		       gprint(apk_packageName,apk_versionCode)
		       print("local_versionCode:" .. apk_versionCode,"server_versionCode:"..versionData.versionCode)
		       gprint("==============apk version compare===================")
		       if apk_versionCode < versionData.versionCode then
		       		callback(false) 
					return 
		       else
		       		callback(true) 
					return 
		       end
		    end)
		end)
end


-- 拉取服务器APK的version信息
function LoginBO.asynGetApkTestStatus(callBack)
	local function getVersionCallback(event)
		local wrapper = event.obj
		local content = wrapper:getData()
		gprint("content",content)
		local data = json.decode(content)
		gdump(data, "LoginBO.asynGetServerApkVersion")
		if callBack then callBack(data) end
	end

    local wrapper = NetWrapper.new(getVersionCallback, nil, true, REQUEST_TYPE_GET, GameConfig.apkTest, false, UpdateText[22])
    wrapper:sendRequest()
end

--获得贪玩SDK 登录帐号
function LoginBO.getTanwanUserId()
	if not GameConfig.sdkLoginToken then return nil end
	local sid = string.split(GameConfig.sdkLoginToken, "_")
	return sid[1]
end