
--
-- 处理对外的接口
-- 

ServiceBO = {}

ServiceBO.coolpadStr = nil
ServiceBO.ftxStr = nil
ServiceBO.userInfo = nil

function ServiceBO.getRunParam(callback)
    gprint("ServiceBO.getRunParam------->", device.platform)
    if device.platform == "android" then
        gprint("callJava", "com/baili/tank/SDKHelper", "getType")
        callJava("com/baili/tank/SDKHelper", "getType", "(I)V", callback)
        gprint("done=====================")
    elseif device.platform == "ios" or device.platform == "mac" then
        callObjectC("CSDKHelper", "getType", nil, callback)
    else
        callback(GameConfig.defaultRunParam)
    end
end

--获取手机的唯一ID
function ServiceBO.getUUID(callback)
    if device.platform == "android" then
        callJava("com/baili/tank/Main", "getUUID", "(I)V", callback)
    elseif device.platform == "ios" or device.platform == "mac" then
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "getDeviceUID", nil, callback)
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "getDeviceUID", nil, callback)
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_getDeviceUID", nil, callback)
        else
            callObjectC("CSDKHelper", "getOpenUDID", nil, callback)
        end
    else
        callback(GameConfig.uuid)
    end
end

function ServiceBO.showNotice(url)
    -- print("ServiceBO.showNotice:" .. url)
    if device.platform == "android" then
        callJava("com/baili/tank/Main", "showNotice", "(Ljava/lang/String;)V", url)
    elseif device.platform == "ios" or device.platform == "mac" then
        callObjectC("CSDKHelper", "showNotice", {url=url})
    else

    end
end

--使用第3方平台sdk登录
function ServiceBO.sdkLogin(callback)
    if GameConfig.environment == "caohua_client" or GameConfig.environment == "chlmzhg_appstore" then
        Toast.show("维护中，暂时无法登录游戏。",3)
        return
    end
    if device.platform == "android" then
        if GameConfig.environment == "tencent_dgzfz" or GameConfig.environment == "tencent_dgwm" 
            or GameConfig.environment == "afYyb_client" then
            callJava("com/baili/tank/SDKHelper", "autoLogin", "(I)V", callback)
        elseif GameConfig.environment == "afAny_client" then
            local data = {}
            data.version = GameConfig.version
            data.baseVersion = GameConfig.baseVersion
            callJava("com/baili/tank/SDKHelper", "login", "(Ljava/lang/String;)V", json.encode(data))
        else
            callJava("com/baili/tank/SDKHelper", "login", "(I)V", callback)
        end
    elseif device.platform == "ios" or device.platform == "mac" then
        local p = {listener=callback}
        if GameConfig.appotaConfig then p.appotaConfig=GameConfig.appotaConfig end
        
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "showlogin", p)
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "showlogin", p)
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_login", p)
        else
            callObjectC("CSDKHelper", "login", p)
        end
    else
        callback("win32")
    end
end

--腾讯手动登录
function ServiceBO.txSdkLogin(callback,type)
    if device.platform == "android" then
        callJava("com/baili/tank/SDKHelper", "txlogin", "(Ljava/lang/String;I)V", type, callback)
    elseif device.platform == "ios" or device.platform == "mac" then
        local p = {listener=callback}
        if GameConfig.appotaConfig then p.appotaConfig=GameConfig.appotaConfig end
        callObjectC("CSDKHelper", "login", p)
    else
        callback("win32")
    end
end

function ServiceBO.txSdkLogout()
    if device.platform == "android" then
        callJava("com/baili/tank/Main", "letUserLogout", "()V")
    elseif device.platform == "ios" or device.platform == "mac" then
        
    else
        callback("win32")
    end
end

--使用第3方平台sdk切换账号
function ServiceBO.switchAccount(callback)
    if device.platform == "android" then
        if callback then 
            callJava("com/baili/tank/SDKHelper", "switchAccount", "(I)V", callback)
        else
            callJava("com/baili/tank/SDKHelper", "switchAccount", "()V")
        end    
    elseif device.platform == "ios" or device.platform == "mac" then
        local p = {unuse = "unuse"}
        if callback then
            p.listener = callback
        end
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "switchSDKUser", p)
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "switchSDKUser", p)
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_switchSDKUser", p)
        else
            callObjectC("CSDKHelper", "switchAccount", p)
        end
    else

    end
end

function ServiceBO.setUserInfo()
    local data = {}
    data.roleId = formatstring(UserMO.lordId_)
    data.roleName = UserMO.nickName_
    data.roleLevel = UserMO.level_
    data.zoneId = GameConfig.areaId
    data.zoneName = string.gsub(LoginMO.getServerById(GameConfig.areaId).name," ","")
    data.vip = UserMO.vip_
    data.coin = UserMO.coin_
    data.roleCTime = UserMO.createRoleTime_
    data.extend = ServiceBO.coolpadStr
    -- gdump(data, "user-----------------")
    if device.platform == "android" then
        callJava("com/baili/tank/SDKHelper", "setUserInfo", "(Ljava/lang/String;)V", json.encode(data))
    elseif device.platform == "ios" or device.platform == "mac" then
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "enterGame", data)
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "enterGame", data)
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_enterGame", data)
        else
            callObjectC("CSDKHelper", "setUserInfo", data)
        end
    else

    end
end

function ServiceBO.userLevelUp()
    local localVersion = LoginBO.getLocalApkVersion()
    --拇指玩和草花的升级统计
    if GameConfig.environment == "u8_dgwm" or GameConfig.environment == "u8_dgzfz" 
        or GameConfig.environment == "n_uc_client" or GameConfig.environment == "ucDgwm_client" 
        or GameConfig.environment == "caohua_client" or GameConfig.environment == "kf_client" 
        or GameConfig.environment == "wdj_client" or GameConfig.environment == "muzhi_zzsd" 
        or GameConfig.environment == "tw_client" or GameConfig.environment == "muzhizzsd_appstore" 
        or GameConfig.environment == "chlmzhg_appstore" or GameConfig.environment == "chdgsdzzwj_appstore" 
        or GameConfig.environment == "chlmfxol_appstore" or GameConfig.environment == "chlmqmzz_appstore" 
        or GameConfig.environment == "chlmzzol_appstore" or GameConfig.environment == "papa_client"
        or GameConfig.environment == "xd_client" or GameConfig.environment == "twzf_client" 
        or GameConfig.environment == "game350_client" or GameConfig.environment == "tanwanLmwm_appstore" 
        or GameConfig.environment == "tanwanQmzz_appstore" or GameConfig.environment == "tanwanWmjq_appstore" 
        or GameConfig.environment == "tanwanDgsd_appstore" or GameConfig.environment == "tanwanDgsd2_appstore" 
        or GameConfig.environment == "tanwanLwzz_appstore" or GameConfig.environment == "zhuayouDgwm_client" 
        or GameConfig.environment == "tanwanLmjq_appstore" or GameConfig.environment == "ftx_client" 
        or GameConfig.environment == "tanwanDgfy_appstore" or GameConfig.environment == "tanwanDwwm_appstore"
        or GameConfig.environment == "yiniu_client" or GameConfig.environment == "anfeng_new_client" 
        or GameConfig.environment == "muzhiqmzz_appstore" or GameConfig.environment == "muzhidgtyz_appstore"
        or GameConfig.environment == "muzhidgby_appstore" or GameConfig.environment == "afDgry_appstore"
        or GameConfig.environment == "muzhiu8_client" or GameConfig.environment == "dgzzfxlm9377_appstore" 
        or GameConfig.environment == "lmdgfxsd9377_appstore" or GameConfig.environment == "dgfxlmdj9377_appstore" 
        or GameConfig.environment == "muzhilmdgsd_appstore" or GameConfig.environment == "af31Dgzz_appstore" 
        or GameConfig.environment == "af31Lmsd_appstore" or GameConfig.environment == "af31Dwsd_appstore"
        or GameConfig.environment == "qwan_client" or GameConfig.environment == "afYiwanWzfx_appstore" 
        or GameConfig.environment == "qianzhiYijie_client" or GameConfig.environment == "qianzhiGuopan_client" 
        or GameConfig.environment == "muzhidglmfx_appstore" or GameConfig.environment == "jq_appstore" 
        or GameConfig.environment == "jqDgjq_appstore" or GameConfig.environment == "jqDgyz_appstore" 
        or GameConfig.environment == "qzDgsdlzzz_appstore" or GameConfig.environment == "qzDgzbol_appstore"
        or GameConfig.environment == "qzZzycx_appstore" or GameConfig.environment == "afBqsd_appstore" 
        or GameConfig.environment == "afCbzz_appstore" or GameConfig.environment == "zsDgyz_appstore" 
        or GameConfig.environment == "zsDgzb_appstore" or GameConfig.environment == "zsDgzf_appstore" 
        or (GameConfig.environment == "anfan_client" and localVersion >= 380) or GameConfig.environment == "muzhiDgzzsd_appstore" 
        or GameConfig.environment == "dgwmNew9377_appstore" or (GameConfig.environment == "af_appstore" and localVersion >= 381) 
        or GameConfig.environment == "zsDgzz_appstore" or GameConfig.environment == "anfanDgzfz_client" 
        or GameConfig.environment == "muzhi_zzsd001" or GameConfig.environment == "muzhi_zzsd002"
        or GameConfig.environment == "muzhi_zzsd003" or GameConfig.environment == "muzhi_zzsd004"
        or GameConfig.environment == "muzhi_zzsd005" or GameConfig.environment == "anfanDgzfzx_client" 
        or GameConfig.environment == "muzhi_dgsm" or GameConfig.environment == "muzhiDgsm_appstore" 
        or GameConfig.environment == "afDgqmzz_appstore" or GameConfig.environment == "muzhiCbzz_appstore" 
        or GameConfig.environment == "muzhiDgxx_appstore" or GameConfig.environment == "muzhiDgqmzz_appstore"
        or GameConfig.environment == "afdgwy_client"  or GameConfig.environment == "qzBwzxQ_appstore" 
        or GameConfig.environment == "tanwanDgjq_appstore" or GameConfig.environment == "qztygsjQuick_client" then
        local data = {}
        data.roleId = formatstring(UserMO.lordId_)
        data.roleName = UserMO.nickName_
        data.roleLevel = UserMO.level_
        data.zoneId = GameConfig.areaId
        data.zoneName = string.gsub(LoginMO.getServerById(GameConfig.areaId).name," ","")
        data.vip = UserMO.vip_
        data.coin = UserMO.coin_
        data.roleCTime = UserMO.createRoleTime_
        -- gdump(data, "user-----------------")
        if device.platform == "android" then
            callJava("com/baili/tank/SDKHelper", "userLevelUp", "(Ljava/lang/String;)V", json.encode(data))
        elseif device.platform == "ios" or device.platform == "mac" then
            if GameConfig.environment == "muzhiCbzz_appstore" then
                callObjectC("MuzhiCbzzUntil", "userLevelUp", data)
            elseif GameConfig.environment == "muzhiDgxx_appstore" then
                callObjectC("MuzhiDgxxUntil", "userLevelUp", data)
            elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
                callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_userLevelUp", data)
            else
                callObjectC("CSDKHelper", "userLevelUp", data)
            end
        else

        end
    end
end

function ServiceBO.creatRole(nick)
    if GameConfig.environment == "weiuu_client" or GameConfig.environment == "37wan_client" 
        or GameConfig.environment == "u8_dgwm" or GameConfig.environment == "u8_dgzfz" 
        or GameConfig.environment == "ky7659_client" or GameConfig.environment == "kf_client" 
        or GameConfig.environment == "wdj_client" or GameConfig.environment == "tw_client" 
        or GameConfig.environment == "papa_client" or GameConfig.environment == "twzf_client"
        or GameConfig.environment == "game350_client" or GameConfig.environment == "tanwanLmwm_appstore" 
        or GameConfig.environment == "tanwanQmzz_appstore" or GameConfig.environment == "tanwanWmjq_appstore" 
        or GameConfig.environment == "tanwanDgsd_appstore" or GameConfig.environment == "tanwanDgsd2_appstore" 
        or GameConfig.environment == "tanwanLwzz_appstore" or GameConfig.environment == "tanwanLmjq_appstore" 
        or GameConfig.environment == "tanwanDgfy_appstore" or GameConfig.environment == "tanwanDwwm_appstore" 
        or GameConfig.environment == "muzhiu8_client" or GameConfig.environment == "qwan_client" 
        or GameConfig.environment == "afYiwanWzfx_appstore" or GameConfig.environment == "qianzhiYijie_client" 
        or GameConfig.environment == "qianzhiGuopan_client" or GameConfig.environment == "qzBwzxQuick_client" 
        or GameConfig.environment == "qzBwzxQuick02_client" or GameConfig.environment == "afdgwy_client" 
        or GameConfig.environment == "tanwanDgjq_appstore" or GameConfig.environment == "qztygsjQuick_client" then
        local data = {}
        data.roleId = formatstring(UserMO.lordId_)
        data.roleName = nick
        data.roleLevel = UserMO.level_
        data.zoneId = GameConfig.areaId
        data.zoneName = string.gsub(LoginMO.getServerById(GameConfig.areaId).name," ","")
        data.vip = UserMO.vip_
        data.coin = UserMO.coin_
        data.roleCTime = ManagerTimer.getTime()
        -- gdump(data, "user-----------------")
        if device.platform == "android" then
            callJava("com/baili/tank/SDKHelper", "creatRole", "(Ljava/lang/String;)V", json.encode(data))
        elseif device.platform == "ios" or device.platform == "mac" then
            callObjectC("CSDKHelper", "creatRole", data)
        else

        end
    end
end

--草花专用 用户绑定
function ServiceBO.userInfoBind(tokenResult)
    if device.platform == "android" then
        callJava("com/baili/tank/SDKHelper", "userInfoBind", "(Ljava/lang/String;)V", tokenResult)
    elseif device.platform == "ios" or device.platform == "mac" then
        --callObjectC("CSDKHelper", "userInfoBind", {user=jdson.encode(data)})
    else

    end
end

function ServiceBO.useGiftCode(code)
    if device.platform == "android" then
        callJava("com/baili/tank/SDKHelper", "useGiftCode", "(Ljava/lang/String;)V", code)
    elseif device.platform == "ios" or device.platform == "mac" then
    else

    end

end



function ServiceBO.pay(callback, rechargeId, notifyUrl, amount, coin, currencyType, paymentType, productName, goodsCount, productId, extraCoin)
    require("app.mo.UserMO")

    if GameConfig.environment == "jqDgjq_appstore" then
        local url = "http://dg.zs4game.com/?serv_id=" .. GameConfig.areaId .. "&usr_name=" .. UserMO.nickName_
        ServiceBO.gotoURL(url)
        return
    end

    gdump(productId,"productId==")

    local p = {}
    p.uid = formatstring(UserMO.lordId_)
    p.ulevel = UserMO.level_
    p.nickName = UserMO.nickName_
    p.serverid = GameConfig.areaId
    p.serverName = string.gsub(LoginMO.getServerById(GameConfig.areaId).name," ","")
    p.rechargeId = rechargeId
    p.notifyUrl = notifyUrl
    p.amount = amount
    p.coin = coin
    p.iapId = string.format(CommonText[737][3], amount) .. coin .. CommonText.item[1][1]
    p.currencyType = currencyType
    p.paymentType = paymentType
    p.productName = productName
    p.goodsCount = goodsCount
    p.productId = productId
    p.oddCoin = UserMO.coin_
    p.extraCoin = extraCoin
    p.coolpadStr = ServiceBO.coolpadStr
    p.ftxStr = ServiceBO.ftxStr
    p.roleCTime = UserMO.createRoleTime_
    p.vip = UserMO.vip_
    p.userInfo = ServiceBO.userInfo
    if GameConfig.environment == "zsDgyz_appstore" or GameConfig.environment == "zsDgzb_appstore" 
        or GameConfig.environment == "zsDgzf_appstore" or GameConfig.environment == "zsDgzz_appstore" then
        p.moneyCode = RechargeMO.getMoneyCode(rechargeId)
        if GameConfig.enableCode then
            p.iosVertifyStatus = 1
        else
            p.iosVertifyStatus = 0
        end
    end

    gdump(p,"recharge param=====")

    if GameConfig.environment == "caohua_client" or GameConfig.environment == "chlmfxol_appstore" or GameConfig.environment == "chlmqmzz_appstore"
        or GameConfig.environment == "chdgsdzzwj_appstore" or GameConfig.environment == "chlmzhg_appstore" then
        Toast.show(CommonText.rechargeClose)
        return
    end
    if device.platform == "android" then
        callJava("com/baili/tank/SDKHelper", "pay", "(Ljava/lang/String;I)V", json.encode(p), callback)
    elseif device.platform == "ios" or device.platform == "mac" then
        p.listener = callback
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "pay", p)
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "pay", p)
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_pay", p)
        else
            callObjectC("CSDKHelper", "pay", p)
        end
        
    else
        -- dump(p, "recharge------------->")
        callback()
    end
end

function ServiceBO.getPackageInfo(callback)
    if device.platform == "android" then
        callJava("com/baili/tank/Main", "getPackageInfo", "(I)V", callback)
    elseif device.platform == "ios" or device.platform == "mac" then
    else
        callback("com.baili.tank.self|100")
    end
end


--获取更新整包APK的下载大小
function ServiceBO.getProgress(callback)
    if device.platform == "android" then
        callJava("com/baili/tank/Main", "getProgress", "(I)V", callback)
    elseif device.platform == "ios" or device.platform == "mac" then
        callObjectC("CSDKHelper", "getProgress", nil, callback)
    end
end

function ServiceBO.updateApk(url)
    if device.platform == "android" then
        callJava("com/baili/tank/Main", "updateApk", "(Ljava/lang/String;)V", url)
    elseif device.platform == "ios" or device.platform == "mac" then
        callObjectC("CSDKHelper", "updateApk", {url=url})
    else

    end
end

function ServiceBO.getIPAddress(callback)
    local localVersion = LoginBO.getLocalApkVersion()
    if (device.platform == "ios" or device.platform == "mac") and localVersion >= 121 then
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "getIPAddress", nil, callback)
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "getIPAddress", nil, callback)
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_getIPAddress", nil, callback)
        else
           callObjectC("CSDKHelper", "getIPAddress", nil, callback) 
        end
    elseif device.platform == "android" and localVersion >= 294 then
        callJava("com/baili/tank/Main", "getIPAddress", "(I)V", callback)
    else
        callback()
    end
end

--贪玩渠道的用户中心
function ServiceBO.tanwanCenter()
    callObjectC("CSDKHelper", "tanwanCenter", nil)
end

--浩林渠道的用户中心
function ServiceBO.haolinCenter()
    callJava("com/baili/tank/SDKHelper", "haolinCenter", "()V")
end

function ServiceBO.iosVertifyStatus()
    p = {}
    if device.platform == "android" then
    elseif device.platform == "ios" or device.platform == "mac" then
        if GameConfig.enableCode then
            p.iosVertifyStatus = 1
        else
            p.iosVertifyStatus = 0
        end
        callObjectC("CSDKHelper", "iosVertifyStatus", p)
    end
end



function ServiceBO.gotoURL(url)
    if device.platform == "ios" or device.platform == "mac" then
        if GameConfig.environment == "muzhiCbzz_appstore" then
            callObjectC("MuzhiCbzzUntil", "gotoURL", {url=url})
        elseif GameConfig.environment == "muzhiDgxx_appstore" then
            callObjectC("MuzhiDgxxUntil", "gotoURL", {url=url})
        elseif GameConfig.environment == "muzhiDgqmzz_appstore" then
            callObjectC("MuzhiDgwmzzUntil", "muzhiDgqmzz_gotoURL", {url=url})
        else
            callObjectC("CSDKHelper", "gotoURL", {url=url})
        end
    elseif device.platform == "android" then
        local localVersion = LoginBO.getLocalApkVersion()
        if localVersion >= 308 then
            callJava("com/baili/tank/Main", "gotoURL", "(Ljava/lang/String;)V", url)
        end
    end
end

--用户中心
function ServiceBO.showAccountCenter()
    if device.platform == "ios" or device.platform == "mac" then
        callObjectC("CSDKHelper", "showAccountCenter", nil)
    end
end

--客服中心
function ServiceBO.showServiceCenter()
    if device.platform == "ios" or device.platform == "mac" then
        callObjectC("CSDKHelper", "showServiceCenter", nil)
    end
end