--
-- Author:
-- Date:
-- 登录场景

require_ex("app.text.LoginText")

LOGIN_TYPE_LOGIN = 1    --登录
LOGIN_TYPE_SWITCH = 2   --切换帐号
LOGIN_TYPE_LOGINOUT = 3 --注销

local function sdkLoginCallback(sid)
    ServiceBO.sdkLoginStatus_ = false
    if sid ~= nil and sid ~= "" then
        local token
        --腾讯特殊判断
        if GameConfig.environment == "tencent_dgzfz" or GameConfig.environment == "tencent_dgwm" 
            or GameConfig.environment == "afYyb_client" then
            local info = string.split(sid, "|")
            local plat = info[1]
            if plat == "1" then
                LOGIN_PLATFORM_PARAM = LOGIN_PLATFORM_PARAM_QQ
            elseif plat == "2" then
                LOGIN_PLATFORM_PARAM = LOGIN_PLATFORM_PARAM_WX
            end
            token = info[2]
        else
            token = sid
        end
        LoginBO.asynSdkLogin(token)
    end
end

local LoginScene = class("LoginScene", function()
    return display.newScene("LoginScene")
end)

function LoginScene:ctor(type)
    -- gprint("LoginScene:ctor ... ")
    local bg = LoginBO.getLoadingBg()
    self:addChild(bg)
    self.bg = bg

    local starttxt = display.newSprite("image/common/label_click_screen_star.png", display.cx, 110)
    starttxt:addTo(self)
    starttxt:setVisible(type and type == LOGIN_TYPE_SWITCH)

    if not type then 
        self.login_type = LOGIN_TYPE_LOGIN 
    else
        self.login_type = type
    end
    if GAME_ORIGIANL_X then
        self:x(GAME_ORIGIANL_X)
        bg:setScale(GAME_X_SCALE_FACTOR)
    end
end

function LoginScene:onEnter()
    gprint("LoginScene:onEnter ... ")

    ----------------------------------------------------------------
    -- 在更新后提前加载协议资源
    ----------------------------------------------------------------
    PbList_init()
    
    -- PbProtocol.preLoadAll()
    PbProtocol.loadPb("Base.pb")
    PbProtocol.loadPb("Account.pb")

    NetQueue.start()

    LoginBO.initLocalAcounts() -- 初始本地保存的账号
    LoginBO.initUUID(handler(self, self.goToLogin))

    
end

function LoginScene:onExit()
end

function LoginScene:goToLogin()
    -- 显示版本号
    local versionLab = ui.newTTFLabel({text = "", font = G_FONT, size = FONT_SIZE_SMALL - 2, x = 10, y = 20, color = ccc3(255, 255, 255)}):addTo(self, 1000)
    versionLab:setAnchorPoint(cc.p(0,0.5))

    --提示语
    ui.newTTFLabelWithOutline({text=UpdateText[26][1],font=G_FONT,size=20,align=ui.TEXT_ALIGN_CENTER})
        :addTo(self):pos(display.cx,135)
    ui.newTTFLabelWithOutline({text=UpdateText[26][2],font=G_FONT,size=20,align=ui.TEXT_ALIGN_CENTER})
        :addTo(self):pos(display.cx,110)

    --显示版署版号相关信息
    if GameConfig.environment == "dybZzyry_appstore" or GameConfig.environment == "xiantu_client" 
        or GameConfig.environment == "dybDgfz1_appstore" or GameConfig.environment == "afDwfz_appstore" or GameConfig.environment == "ifeng_client" 
        or GameConfig.environment == "dianyou_client" or GameConfig.environment == "dybDgfz_appstore" or GameConfig.environment == "n_uc_client" 
        or GameConfig.environment == "qihoo360_client" or GameConfig.environment == "game350_client" or GameConfig.environment == "baidu_client" 
        or GameConfig.environment == "anfan_client" or GameConfig.environment == "af_appstore" or GameConfig.environment == "afYiwanWzfx_appstore" 
        or GameConfig.environment == "yyh_client" or GameConfig.environment == "yiniu_client" or GameConfig.environment == "duwan_client" 
        or GameConfig.environment == "sougou_client" or GameConfig.environment == "ky7659_client" or GameConfig.environment == "wdj_client" 
        or GameConfig.environment == "kf_client" or GameConfig.environment == "anzhi_client" or GameConfig.environment == "nubia_client" 
        or GameConfig.environment == "leqi_client" or GameConfig.environment == "afYyb_client" or GameConfig.environment == "youyou_client" 
        or GameConfig.environment == "6kw_client" or GameConfig.environment == "afDgwm_appstore" or GameConfig.environment == "coolpad_dgwm" 
        or GameConfig.environment == "huaweiDgwm_client" or GameConfig.environment == "lenovoDgwm_client" or GameConfig.environment == "mi_dgwm" 
        or GameConfig.environment == "mz_dgwm" or GameConfig.environment == "oppo_dgwm" or GameConfig.environment == "vivo_dgwm" 
        or GameConfig.environment == "anfanDgwm_client" or GameConfig.environment == "zhuayouDgwm_client" or GameConfig.environment == "letv_dgwm" 
        or GameConfig.environment == "afAz_dgwm" or GameConfig.environment == "papa_client" or GameConfig.environment == "afdmlmzfz_appstore" 
        or GameConfig.environment == "afdmDgfy_appstore" or GameConfig.environment == "ftx_client" or GameConfig.environment == "af31Lmsd_appstore" 
        or GameConfig.environment == "af31Dwsd_appstore" or GameConfig.environment == "af1_appstore" or GameConfig.environment == "afAny_client"
        or GameConfig.environment == "afDgry_appstore" or GameConfig.environment == "afDgwmba_appstore" or GameConfig.environment == "afDgwmol_appstore"
        or GameConfig.environment == "afDgzfz_appstore" or GameConfig.environment == "afDgzfzHD_appstore" or GameConfig.environment == "afQwDdg_appstore"
        or GameConfig.environment == "anfeng_new_client" or GameConfig.environment == "caohua_client" or GameConfig.environment == "chdgsdzzwj_appstore"
        or GameConfig.environment == "chlmfxol_appstore" or GameConfig.environment == "chlmqmzz_appstore" or GameConfig.environment == "chlmzhg_appstore"
        or GameConfig.environment == "chlmzzol_appstore" or GameConfig.environment == "dybDgfz_appstore" or GameConfig.environment == "haolin_client"
        or GameConfig.environment == "muzhilmdgsd_appstore" or GameConfig.environment == "tencent_dgwm" or GameConfig.environment == "tencent_dgzfz" or GameConfig.environment == "u8_dgwm"
        or GameConfig.environment == "ucDgwm_client" or GameConfig.environment == "xd_client" or GameConfig.environment == "xmw_client"
        or GameConfig.environment == "youyou_appstore" or GameConfig.environment == "zhuayouDgwm2_client"  or GameConfig.environment == "u8_dgzfz" 
        or GameConfig.environment == "af31Dgzz_appstore" or GameConfig.environment == "afQwDgdry_appstore" or GameConfig.environment == "afBqsd_appstore" or GameConfig.environment == "afCbzz_appstore" 
        or GameConfig.environment == "anfanDgzfz_client" or GameConfig.environment == "anfanDgzfzx_client" or GameConfig.environment == "afDgqmzz_appstore" then
        ui.newTTFLabelWithOutline({text=LoginText[62][1],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
            :addTo(self):pos(display.cx,90)
        ui.newTTFLabelWithOutline({text=LoginText[62][2],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
           :addTo(self):pos(display.cx,70)
       ui.newTTFLabelWithOutline({text=LoginText[62][3],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
           :addTo(self):pos(display.cx,50)
    elseif GameConfig.environment == "muzhiu8_client" or GameConfig.environment == "muzhi_zzsd" or GameConfig.environment == "muzhizzsd_appstore"
        or GameConfig.environment == "muzhiqmzz_appstore" or GameConfig.environment == "muzhidgtyz_appstore" or GameConfig.environment == "muzhidgby_appstore" 
        or GameConfig.environment == "muzhi_zzsd001" or GameConfig.environment == "muzhi_zzsd002"
        or GameConfig.environment == "muzhi_zzsd003" or GameConfig.environment == "muzhi_zzsd004"
        or GameConfig.environment == "muzhi_zzsd005" then
         ui.newTTFLabelWithOutline({text=LoginText[63][1],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
             :addTo(self):pos(display.cx,90)
         ui.newTTFLabelWithOutline({text=LoginText[63][2],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
            :addTo(self):pos(display.cx,70)
        ui.newTTFLabelWithOutline({text=LoginText[63][3],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
            :addTo(self):pos(display.cx,50)
    elseif GameConfig.environment == "qzBwzxHw_client" or GameConfig.environment == "qzBwzxBaidu_client" or GameConfig.environment == "qzBwzxMeizu_client" 
        or GameConfig.environment == "qzBwzxGionee_client" or GameConfig.environment == "qzBwzxXiaomi_client" or GameConfig.environment == "qzBwzxOppo_client"
        or GameConfig.environment == "qzBwzx360_client" or GameConfig.environment == "qzBwzxLenovo_client" or GameConfig.environment == "qzBwzxQuick_client"
         or GameConfig.environment == "qzBwzxQuick02_client" or GameConfig.environment == "qztygsjQuick_client" then
        ui.newTTFLabelWithOutline({text=LoginText[65][1],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
             :addTo(self):pos(display.cx,90)
         ui.newTTFLabelWithOutline({text=LoginText[65][2],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
            :addTo(self):pos(display.cx,70)
        ui.newTTFLabelWithOutline({text=LoginText[65][3],font=G_FONT,size=18,align=ui.TEXT_ALIGN_CENTER,color = cc.c3b(205, 205, 205)})
            :addTo(self):pos(display.cx,50)
    end

    if GAME_APK_VERSION then
        versionLab:setString("Version:" .. GAME_APK_VERSION .. "@" .. GameConfig.version)
    else
        versionLab:setString("Version:" .. GameConfig.version)
    end
    
    if device.platform == "android" or device.platform == "ios" or device.platform == "mac" then 
        if GameConfig.environment ~= "self_client" and GameConfig.environment ~= "ipay_client" 
        and GameConfig.environment ~= "ipay_101_client" and GameConfig.environment ~= "ios_client"
        and GameConfig.environment ~= "appstore_ios"  and GameConfig.environment ~= "zty_nake_client" 
        and GameConfig.environment ~= "tanwan_self" and GameConfig.environment == "tygsj2_pc_client" then
            nodeTouchEventProtocol(self.bg, function(event)  
                    -- gprint("clickme")
                    -- if ServiceBO.sdkLoginStatus_ == true then return end
                    -- ServiceBO.sdkLoginStatus_ = true
                    if self.login_type == LOGIN_TYPE_LOGIN or self.login_type == LOGIN_TYPE_LOGINOUT then
                        ServiceBO.sdkLogin(sdkLoginCallback)
                    else
                        ServiceBO.switchAccount()
                    end
                    
                end, nil, true)
        end
    end  

    if LoginBO.isSelfLogin() then
        self:showSelfLogin()
    else
        -- ServiceBO.sdkLoginStatus_ = true
        -- ServiceBO.sdkLogin(sdkLoginCallback)
        if self.login_type == LOGIN_TYPE_LOGIN then
            ServiceBO.sdkLogin(sdkLoginCallback)
            
        else
            -- ServiceBO.switchAccount()
        end
        if GameConfig.environment == "tencent_dgzfz" or GameConfig.environment == "tencent_dgwm" 
            or GameConfig.environment == "afYyb_client" then
            --QQ登录按钮
            local normal = display.newSprite("zLoginBg/btn_qq_normal.png")
            local selected = display.newSprite("zLoginBg/btn_qq_selected.png")
            local qqLoginBtn = MenuButton.new(normal, selected, nil, handler(self, self.onTxLoginCallback))
            qqLoginBtn:setPosition(display.cx - 150, display.cy - 350)
            qqLoginBtn.type = "qq"
            self:addChild(qqLoginBtn)

            --微信登录按钮
            local normal = display.newSprite("zLoginBg/btn_wx_normal.png")
            local selected = display.newSprite("zLoginBg/btn_wx_selected.png")
            local wxLoginBtn = MenuButton.new(normal, selected, nil, handler(self, self.onTxLoginCallback))
            wxLoginBtn:setPosition(display.cx + 150, display.cy - 350)
            wxLoginBtn.type = "wx"
            self:addChild(wxLoginBtn)
        end
    end
end

function LoginScene:onTxLoginCallback(tag, sender)
    ServiceBO.txSdkLogin(sdkLoginCallback,sender.type)
end

function LoginScene:showSelfLogin()
    -- 显示登录
    self:showLogin(true)
end

function LoginScene:showLogin(canSee)
    if not self.m_loginBg then
        local abg = display.newScale9Sprite(IMAGE_COMMON .. "bg_dlg_1.png", display.cx, display.cy - 50)
        abg:setPreferredSize(cc.size(abg:getContentSize().width, 702))
        abg:setCapInsets(cc.rect(323, 150, 1, 1))
        self:addChild(abg)
        self.m_loginBg = abg

        local container = display.newSprite(IMAGE_COMMON .. "info_bg_11.jpg"):addTo(abg)
        container:setPosition(abg:getContentSize().width / 2, abg:getContentSize().height / 2 - 34)

        -- local btm = display.newSprite(IMAGE_COMMON .. "info_bg_10.jpg"):addTo(abg, -1)
        -- btm:setPosition(abg:getContentSize().width / 2, abg:getContentSize().height / 2 - 6)
        -- btm:setScaleY((abg:getContentSize().height - 70) / btm:getContentSize().height)

        -- local labelColor = cc.c3b(98,165,210)

        local title = ui.newTTFLabel({text = LoginText[50], font = G_FONT, size = FONT_SIZE_BIG, x = abg:getContentSize().width / 2,
            y = abg:getContentSize().height - 68, align = ui.TEXT_ALIGN_CENTER}):addTo(abg)

        local contentBg = display.newScale9Sprite(IMAGE_COMMON .. "info_bg_20.jpg"):addTo(container)
        contentBg:setPosition(container:getContentSize().width / 2, container:getContentSize().height - 8 - contentBg:getContentSize().height / 2)

        local function onEdit(event, editbox)
            if editbox:getText() == LoginText[1][1] or editbox:getText() == LoginText[2][1] then
                editbox:setText("")
            end
        end

        local width = 400
        local height = UiUtil.getEditBoxHeight(FONT_SIZE_SMALL)

        local inputBg = display.newScale9Sprite(IMAGE_COMMON .. "btn_7_unchecked.png"):addTo(contentBg)
        inputBg:setPreferredSize(cc.size(width + 20, height + 10))
        inputBg:setPosition(contentBg:getContentSize().width / 2, contentBg:getContentSize().height / 2)

        -- 账号输入框
        local loginInput1 = ui.newEditBox({x = inputBg:getPositionX(), y = inputBg:getPositionY(),
            size = cc.size(width, height), listener = onEdit}):addTo(contentBg)
        loginInput1:setText(LoginText[1][1])

        local contentBg1 = display.newScale9Sprite(IMAGE_COMMON .. "info_bg_20.jpg"):addTo(container)
        contentBg1:setPosition(container:getContentSize().width / 2,
            contentBg:getPositionY() - contentBg:getContentSize().height / 2 - contentBg1:getContentSize().height / 2)

        local inputBg = display.newScale9Sprite(IMAGE_COMMON .. "btn_7_unchecked.png"):addTo(contentBg1)
        inputBg:setPreferredSize(cc.size(width + 20, height + 10))
        inputBg:setPosition(contentBg1:getContentSize().width / 2, contentBg1:getContentSize().height / 2)

        -- 密码输入框
        local loginInput2 = ui.newEditBox({x = inputBg:getPositionX(), y = inputBg:getPositionY(),
            size = cc.size(width, height), listener = onEdit}):addTo(contentBg1)
        loginInput2:setText(LoginText[2][1])
        loginInput2:setInputFlag(0)

        -- self.downArrow = display.newSprite(IMAGE_COMMON .. "login/down.png", display.cx + 180, display.cy + 25):addTo(self.m_loginBg)
    --     Helper.addTouchEvent(self.downArrow, function(event, x, y)
    --         if event.name == "ended" then
    --             ManagerSound.playNormalButtonSound()
    --             self:showHisAccount()
    --         end
    --         return true
    --         end)


        local accounts = LoginMO.getLocalAccounts()
        if accounts and #accounts > 0 then
            local account = accounts[1]
            loginInput1:setText(account.accountId)
            loginInput2:setText(account.passwd)
        end
    --     AccountService.getAccount()
    --     if AccountService.loginHis and #AccountService.loginHis > 0 then
    --         self.loginShow = clone(AccountService.loginHis)
    --         local acc = table.remove(self.loginShow,1)
    --         self.downArrow:setVisible(self.loginShow and #self.loginShow > 0)
    --         -- self.upArrow:setVisible(false)
    --         if acc then
    --             loginInput1:setText(acc.accountId)
    --             loginInput2:setText(acc.passwd)
    --         end
    --     else
    --         self.downArrow:setVisible(false)
    --     end
        
        self.loginInput1 = loginInput1
        self.loginInput2 = loginInput2

        local btmShade = display.newScale9Sprite(IMAGE_COMMON .. "info_bg_95.jpg"):addTo(container, 2)
        btmShade:setPreferredSize(cc.size(container:getContentSize().width + 8, 300))
        btmShade:setPosition(container:getContentSize().width / 2, btmShade:getContentSize().height / 2 - 2)

        --登录按钮
        local normal = display.newSprite(IMAGE_COMMON.."btn_1_normal.png")
        local selected = display.newSprite(IMAGE_COMMON.."btn_1_selected.png")
        local loginBtn = MenuButton.new(normal, selected, nil, handler(self, self.onLoginCallback)):addTo(btmShade)
        loginBtn:setLabel(LoginText[22])
        loginBtn:setPosition(btmShade:getContentSize().width / 2 + 120, 50)

        --注册按钮
        local normal = display.newSprite(IMAGE_COMMON.."btn_10_normal.png")
        local selected = display.newSprite(IMAGE_COMMON.."btn_10_selected.png")
        local registerBtn = MenuButton.new(normal, selected, nil, function() ManagerSound.playNormalButtonSound(); self:showRegister(true) end):addTo(btmShade)
        registerBtn:setLabel(LoginText[23])
        registerBtn:setPosition(btmShade:getContentSize().width / 2 - 120, 50)
    end

    if canSee then
        self.m_loginBg:setVisible(true)
        if self.m_registerBg then self.m_registerBg:setVisible(false) end
    else
        self.m_loginBg:setVisible(false)
        if self.m_registerBg then self.m_registerBg:setVisible(true) end
    end
end

-- function LoginScene:showHisAccount()
--     --如果帐号删除只剩一个，则关闭下拉窗口,隐藏下拉箭头
--     if #AccountService.loginHis == 1 then
--         self:closeHisAccount()
--         self.downArrow:setVisible(false)
--         return
--     end
--     -- self.upArrow:setVisible(true)
--     self.downArrow:setVisible(false)

--     if self.accountSView then
--         self.accountSView:setVisible(true)
--         self.accountSLabel:setString(self.loginInput1:getText())
--     end

--     if self.accountsView then
--         self.accountsView:setVisible(true)
--         self.loginShow = clone(AccountService.loginHis)
--         for i=1,#self.loginShow do
--             if self.loginShow[i].accountId == self.loginInput1:getText() then
--                 table.remove(self.loginShow,i)
--                 break
--             end
--         end

--         self.accountTableView:resetData(self.loginShow)
--         return
--     end

    

--     self.accountsView = display.newScale9Sprite(IMAGE_COMMON.."login/accountsBg.png",winSize.width / 2, winSize.height / 2 - 80)
--     self.accountsView:setPreferredSize(CCSizeMake(434, 165))
--     self.m_loginBg:addChild(self.accountsView)


--     self.accountSView = display.newScale9Sprite(IMAGE_COMMON.."login/accountsBg.png",winSize.width / 2, winSize.height / 2 + 25)
--     self.accountSView:setPreferredSize(CCSizeMake(434, 66))
--     self.m_loginBg:addChild(self.accountSView)
--     self.upArrow = display.newSprite(IMAGE_COMMON .. "login/up.png", 395,32)
--     self.upArrow:setScaleY(0.85)
--     self.accountSView:addChild(self.upArrow)

--     self.accountSLabel = CCLabelTTF:create(self.loginInput1:getText(), FONTS, 25)
--     self.accountSLabel:setAnchorPoint(ccp(0, 0.5))
--     self.accountSLabel:setPosition(35,30)
--     self.accountSLabel:setColor(ccc3(0,0,0))
--     self.accountSView:addChild(self.accountSLabel)

--     Helper.addTouchEvent(self.accountSView, function(event, x, y)
--         if event.name == "ended" then
--             ManagerSound.playNormalButtonSound()
--             self:closeHisAccount()
--         end
--         return true
--         end,true)

--     -- dump(self.loginHis)
    
--     local rect = CCRectMake(0, 0, 400, 140)
--     -- dump(GangDM.partyList)
--     local accountTableView = AccountListView.new(rect, self.loginShow, 1)
    

--     accountTableView:addEventListener("onItemClicked", handler(self, self.onItemClicked))
--     accountTableView:setPosition(15,10)
--     self.accountsView:addChild(accountTableView)
--     self.accountTableView = accountTableView
-- end

-- function LoginScene:closeHisAccount()
--     -- self.upArrow:setVisible(false)
--     self.downArrow:setVisible(true)
--     self.accountsView:setVisible(false)
--     self.accountSView:setVisible(false)
-- end

-- function LoginScene:onItemClicked(event)
--     self:closeHisAccount()
--     self.loginInput1:setText(event.data.accountId)
--     self.loginInput2:setText(event.data.passwd)
-- end

function LoginScene:showRegister(canSee)
    if not self.m_registerBg then
        local abg = display.newScale9Sprite(IMAGE_COMMON .. "bg_dlg_1.png", display.cx, display.cy - 50)
        abg:setPreferredSize(cc.size(646, 587))
        self:addChild(abg)
        self.m_registerBg = abg

        -- local btm = display.newSprite(IMAGE_COMMON .. "info_bg_10.jpg"):addTo(abg, -1)
        -- btm:setPosition(abg:getContentSize().width / 2, abg:getContentSize().height / 2 - 6)
        -- btm:setScaleY((abg:getContentSize().height - 70) / btm:getContentSize().height)

        local labelColor = cc.c3b(98,165,210)

        local tilte = ui.newTTFLabel({text = LoginText[51], font = G_FONT, size = FONT_SIZE_MEDIUM, x = self.m_registerBg:getContentSize().width / 2, y = self.m_registerBg:getContentSize().height - 26, align = ui.TEXT_ALIGN_CENTER}):addTo(self.m_registerBg)

        local onEdit = function(event, editbox)
            if editbox:getText() == LoginText[1][1] or editbox:getText() == LoginText[2][1] or editbox:getText() == LoginText[3][1] then
                editbox:setText("")
            end
        end

        local width = 400
        local height = UiUtil.getEditBoxHeight(FONT_SIZE_SMALL)

        local inputBg = display.newScale9Sprite(IMAGE_COMMON .. "btn_7_unchecked.png"):addTo(self.m_registerBg)
        inputBg:setPreferredSize(cc.size(width + 20, height + 10))
        inputBg:setPosition(self.m_registerBg:getContentSize().width / 2, self.m_registerBg:getContentSize().height - 180)

        local regInput1 = ui.newEditBox({x = self.m_registerBg:getContentSize().width / 2, y = self.m_registerBg:getContentSize().height - 180, size = cc.size(width, height), listener = onEdit}):addTo(self.m_registerBg)
        regInput1:setFontSize(16)
        regInput1:setFontColor(labelColor)
        regInput1:setText(LoginText[1][1])

        local inputBg = display.newScale9Sprite(IMAGE_COMMON .. "btn_7_unchecked.png"):addTo(self.m_registerBg)
        inputBg:setPreferredSize(cc.size(width + 20, height + 10))
        inputBg:setPosition(self.m_registerBg:getContentSize().width / 2, self.m_registerBg:getContentSize().height - 280)

        local regInput2 = ui.newEditBox({x = self.m_registerBg:getContentSize().width / 2, y = self.m_registerBg:getContentSize().height - 280, size = cc.size(width, height), listener = onEdit}):addTo(self.m_registerBg)
        regInput2:setFontSize(16)
        regInput2:setFontColor(labelColor)
        regInput2:setText(LoginText[2][1])
        regInput2:setInputFlag(0)

        local inputBg = display.newScale9Sprite(IMAGE_COMMON .. "btn_7_unchecked.png"):addTo(self.m_registerBg)
        inputBg:setPreferredSize(cc.size(width + 20, height + 10))
        inputBg:setPosition(self.m_registerBg:getContentSize().width / 2, self.m_registerBg:getContentSize().height - 380)

        local regInput3 = ui.newEditBox({x = self.m_registerBg:getContentSize().width / 2, y = self.m_registerBg:getContentSize().height - 380, size = cc.size(width, height), listener = onEdit}):addTo(self.m_registerBg)
        regInput3:setFontSize(16)
        regInput3:setFontColor(labelColor)
        regInput3:setText(LoginText[3][1])
        regInput3:setInputFlag(0)

        self.m_registerBg.input1 = regInput1
        self.m_registerBg.input2 = regInput2
        self.m_registerBg.input3 = regInput3

        -- 返回按钮
        local normal = display.newSprite(IMAGE_COMMON .. "btn_2_normal.png")
        local selected = display.newSprite(IMAGE_COMMON.."btn_2_selected.png")
        local loginBtn = MenuButton.new(normal, selected, nil, function() ManagerSound.playNormalButtonSound(); self:showLogin(true) end)
        loginBtn:setLabel(LoginText[24])
        loginBtn:setPosition(self.m_registerBg:getContentSize().width / 2 - 120, 25)
        self.m_registerBg:addChild(loginBtn)

        --注册按钮
        local normal = display.newSprite(IMAGE_COMMON .. "btn_1_normal.png")
        local selected = display.newSprite(IMAGE_COMMON .. "btn_1_selected.png")
        local registerBtn = MenuButton.new(normal, selected, nil, function() ManagerSound.playNormalButtonSound(); self:register() end)
        registerBtn:setLabel(LoginText[23])
        registerBtn:setPosition(self.m_registerBg:getContentSize().width / 2 + 120, 25)
        self.m_registerBg:addChild(registerBtn)
    end

    if canSee then
        self.m_loginBg:setVisible(false)
        self.m_registerBg:setVisible(true)
    else
        self.m_loginBg:setVisible(true)
        self.m_registerBg:setVisible(false)
    end
end

-- 点击登录按钮
function LoginScene:onLoginCallback(tag, sender)
    ManagerSound.playNormalButtonSound()

    local email = string.gsub(self.loginInput1:getText(), " ", "")
    local pwd = string.gsub(self.loginInput2:getText(), " ", "")

    gprint("[LoginScene] login account:", email, "pwd:", pwd)

    if email == "" or pwd == "" then
        Toast.show(LoginText[6])
        return
    end

    -- 必须是字母和数字
    if string.find(email,"%W") ~= nil or string.find(pwd,"%W") ~= nil then
        Toast.show(LoginText[31])
        return
    end

    LoginBO.asynAccountLogin(email, pwd)
end

function LoginScene:register()
    -- if true then
    --     require("app.bo.TestRegisterBO")
    --     TestRegisterBO.start()
    --     return
    -- end

    local email = string.gsub(self.m_registerBg.input1:getText()," ","")
    local pwd1 = string.gsub(self.m_registerBg.input2:getText()," ","")
    local pwd2 = string.gsub(self.m_registerBg.input3:getText()," ","")

    gprint("[LoginScene] register: email", email, "pwd1", pwd1, "pwd2", pwd2)

    if email == "" or pwd1 == "" then
        Toast.show(LoginText[6])
        return
    end

    if pwd1 ~= pwd2 then
--         --print("两次密码不相等")
        Toast.show(LoginText[7])
        return
    end

    if string.find(email, "%W") ~= nil or string.find(pwd1, "%W") ~= nil or string.find(pwd2, "%W") ~= nil then
        Toast.show(LoginText[31])
        return
    end

    local length = string.len(email)
    if length > REGISTER_NAME_MAX_LEN then
        Toast.show(string.format(LoginText[36],REGISTER_NAME_MAX_LEN))
        return
    end

    LoginBO.asynRegistAccount(email, pwd1)
end

return LoginScene