
require("app.text.DetailText")

local VipPageView = class("VipPageView", PageView)

function VipPageView:ctor(size)
	VipPageView.super.ctor(self, size, SCROLL_DIRECTION_HORIZONTAL)

	self.m_cellSize = size
end

function VipPageView:numberOfCells()
	return VipMO.queryMaxVip()
end

function VipPageView:cellSizeForIndex(index)
	return self:getViewSize()
end

function VipPageView:createCellAtIndex(cell, index)
	VipPageView.super.createCellAtIndex(self, cell, index)

	local componentBg = display.newScale9Sprite(IMAGE_COMMON .. "info_bg_76.png"):addTo(cell)
	componentBg:setPreferredSize(cc.size(self.m_cellSize.width, self.m_cellSize.height))
	componentBg:setPosition(self:getViewSize().width / 2, self:getViewSize().height / 2)
	componentBg:setOpacity(0)

	local labelColor = cc.c3b(0, 0, 0)

	-- VIP特权
	-- local title = ui.newTTFLabel({text =  string.format(CommonText[408], index), font = G_FONT, size = FONT_SIZE_HUGE, x = self.m_cellSize.width / 2, y = self.m_cellSize.height - 40, color = labelColor, align = ui.TEXT_ALIGN_CENTER}):addTo(cell)

	local posY = self.m_cellSize.height - 10

	local data = DetailText.vip[index]

	if data then
		for index = 1, #data do
			local d = data[index]
			local label = RichLabel.new(d, cc.size(self.m_cellSize.width, 0)):addTo(cell)
			label:setPosition(0, posY)
			label:setTouchEnabled(false)
			posY = posY - label:getHeight()
		end
	end

	return cell
end

function VipPageView:onDetailCallback(tag, sender)
	-- local DetailPartDialog =  require("app.dialog.DetailPartDialog")
	-- DetailPartDialog.new():push()
end

-----------------------------------------------------------------
-----------------------------------------------------------------

local VipView = class("VipView", UiNode)

function VipView:ctor()
	VipView.super.ctor(self, "image/common/bg_ui.jpg", UI_ENTER_FADE_IN_GATE)
end

function VipView:onEnter()
	VipView.super.onEnter(self)
	
	self:hasCoinButton(true)
	self:setTitle(CommonText[264])

	self:setUI()
end

function VipView:setUI()
	local container = display.newNode():addTo(self:getBg())
	container:setAnchorPoint(cc.p(0.5, 0.5))
	container:setContentSize(cc.size(display.width - 12, display.height - 150 + 70))
	container:setPosition(self:getBg():getContentSize().width / 2, 6 + container:getContentSize().height / 2)

	local bg = display.newSprite(IMAGE_COMMON .. "info_bg_45.jpg"):addTo(container)
	bg:setPosition(bg:getContentSize().width / 2, container:getContentSize().height - bg:getContentSize().height / 2 - 4)

	local titleBar = display.newSprite(IMAGE_COMMON .. "activity/bar_1.jpg"):addTo(bg)
	titleBar:setPosition(bg:getContentSize().width / 2, bg:getContentSize().height / 2)

	-- 充值就送
	local label = ui.newTTFLabel({text = CommonText[370][2], font = G_FONT, size = FONT_SIZE_BIG, x = 20, y = bg:getContentSize().height - 40,
		align = ui.TEXT_ALIGN_LEFT, color = COLOR[11]}):addTo(bg)

	-- VIP特权
	local label = ui.newTTFLabel({text = CommonText[370][3], font = G_FONT, size = FONT_SIZE_BIG, x = 20, y = bg:getContentSize().height - 80,
		align = ui.TEXT_ALIGN_LEFT, color = COLOR[11]}):addTo(bg)

	--超级VIP小秘书
	if GameConfig.environment == "tw_client" or GameConfig.environment == "twzf_client"
		or GameConfig.environment == "tanwanQmzz_appstore" or GameConfig.environment == "tanwanWmjq_appstore"
		or GameConfig.environment == "tanwanDgsd_appstore" or GameConfig.environment == "tanwan_dgsd2_appstore"
		or GameConfig.environment == "tanwanLmwm_appstore" or GameConfig.environment == "tanwanLwzz_appstore"
		or GameConfig.environment == "tanwanLmjq_appstore" or GameConfig.environment == "tanwanDgfy_appstore" 
		or GameConfig.environment == "self_client" or GameConfig.environment == "tanwanDwwm_appstore" 
		or GameConfig.environment == "tanwanDgjq_appstore" or GameConfig.environment == "tygsj2_pc_client" then
		local function onSecretaryCallback(tag, sender)
			ManagerSound.playNormalButtonSound()
			local vipServiceView = require("app.view.VipServiceView")
			vipServiceView.new():push()
		end

		local normal = display.newSprite(IMAGE_COMMON .. "btn_55_normal.png")
		local selected = display.newSprite(IMAGE_COMMON .. "btn_55_selected.png")
		local btn = MenuButton.new(normal, selected, nil, onSecretaryCallback):addTo(bg)
		btn:setPosition(bg:getContentSize().width - btn:getContentSize().width / 2 - 20,75)
		btn:setLabel(CommonText[979])
		btn:runAction(cc.RepeatForever:create(transition.sequence({cc.ScaleTo:create(1.8, 1.1), cc.ScaleTo:create(2.2, 0.9)})))
		btn:setVisible(UserMO.vip_ >= 7)
	end

	if UserMO.vip_ >= VipMO.queryMaxVip() then -- 已经是最高VIP了
	else
		local nxtVip = VipMO.queryVip(UserMO.vip_ + 1)

		-- 再充值
		local label = ui.newTTFLabel({text = string.format(CommonText[370][1], (nxtVip.topup - UserMO.topup_), (UserMO.vip_ + 1)),
			font = G_FONT, size = FONT_SIZE_SMALL, x = 20, y = 75, align = ui.TEXT_ALIGN_CENTER}):addTo(bg)
		label:setAnchorPoint(cc.p(0, 0.5))
	end

	local infoBg = display.newScale9Sprite(IMAGE_COMMON .. "info_bg_84.jpg"):addTo(bg)
	infoBg:setPreferredSize(cc.size(600, infoBg:getContentSize().height))
	infoBg:setPosition(bg:getContentSize().width / 2, 36)

	local vipBg = display.newSprite(IMAGE_COMMON .. "info_bg_97.png"):addTo(infoBg, 2)
	vipBg:setPosition(vipBg:getContentSize().width / 2, infoBg:getContentSize().height / 2)

	local label = ui.newTTFLabel({text = "VIP" .. UserMO.vip_, font = G_FONT, size = FONT_SIZE_SMALL, x = 10, y = vipBg:getContentSize().height / 2,
		color = COLOR[11]}):addTo(vipBg)

	local bar = ProgressBar.new(IMAGE_COMMON .. "bar_4.png", BAR_DIRECTION_HORIZONTAL, cc.size(520, 24),
		{bgName = IMAGE_COMMON .. "bar_bg_2.png", bgScale9Size = cc.size(520 + 10, 32)}):addTo(infoBg)
	bar:setPosition(78 + bar:getContentSize().width / 2, vipBg:getPositionY())

	local curVip = VipMO.queryVip(UserMO.vip_)
	
	if UserMO.vip_ >= VipMO.queryMaxVip() then -- 已经是最高VIP了
		bar:setPercent(1)
		bar:setLabel(UserMO.topup_ .. "/" .. curVip.topup)
	else
		local nxtVip = VipMO.queryVip(UserMO.vip_ + 1)

		bar:setPercent((UserMO.topup_ - curVip.topup) / (nxtVip.topup - curVip.topup))
		bar:setLabel(UserMO.topup_ .. "/" .. nxtVip.topup)
	end

	local btm = display.newSprite(IMAGE_COMMON .. "info_bg_87.jpg"):addTo(container)
	btm:setPosition(container:getContentSize().width / 2, bg:getPositionY() - bg:getContentSize().height / 2 - btm:getContentSize().height / 2)

	local vipBg = display.newSprite(IMAGE_COMMON .. "info_bg_89.png"):addTo(btm)
	vipBg:setPosition(vipBg:getContentSize().width / 2, btm:getContentSize().height - 10 - vipBg:getContentSize().height / 2)
	
	-- VIP特权
	local title = ui.newTTFLabel({text = "", font = G_FONT, size = FONT_SIZE_MEDIUM,
		x = 30, y = vipBg:getContentSize().height / 2, align = ui.TEXT_ALIGN_CENTER}):addTo(vipBg)
	title:setAnchorPoint(cc.p(0, 0.5))
	self.m_vipLabel = title

	local contentBg = display.newScale9Sprite(IMAGE_COMMON .. "info_bg_76.png"):addTo(btm)
	contentBg:setPreferredSize(cc.size(480, 470))
	contentBg:setPosition(btm:getContentSize().width / 2, vipBg:getPositionY() - vipBg:getContentSize().height / 2 - 10 - contentBg:getContentSize().height / 2)

	-- 充值
	local normal = display.newSprite(IMAGE_COMMON .. "btn_10_normal.png")
	local selected = display.newSprite(IMAGE_COMMON .. "btn_10_selected.png")
	local btn = MenuButton.new(normal, selected, nil, handler(self, self.onChargeCallback)):addTo(btm)
	btn:setPosition(btm:getContentSize().width / 2, contentBg:getPositionY() - contentBg:getContentSize().width / 2 - 10 - btn:getContentSize().height / 2)
	btn:setLabel(CommonText[369])

	local normal = display.newSprite(IMAGE_COMMON .. "icon_arrow_5.png")
	normal:setScaleX(-1)
	local selected = display.newSprite(IMAGE_COMMON .. "icon_arrow_5.png")
	selected:setScaleX(-1)
	local lastBtn = MenuButton.new(normal, selected, nil, handler(self, self.onLastCallback)):addTo(btm)
	lastBtn:setPosition(40, contentBg:getPositionY())
	lastBtn:runAction(cc.RepeatForever:create(transition.sequence({cc.MoveBy:create(2, cc.p(-20, 0)), cc.MoveBy:create(2, cc.p(20, 0))})))

	local normal = display.newSprite(IMAGE_COMMON .. "icon_arrow_5.png")
	local selected = display.newSprite(IMAGE_COMMON .. "icon_arrow_5.png")
	local nxtBtn = MenuButton.new(normal, selected, nil, handler(self, self.onNextCallback)):addTo(btm)
	nxtBtn:setPosition(btm:getContentSize().width - 40, contentBg:getPositionY())
	nxtBtn:runAction(cc.RepeatForever:create(transition.sequence({cc.MoveBy:create(2, cc.p(20, 0)), cc.MoveBy:create(2, cc.p(-20, 0))})))

	local pageView = VipPageView.new(cc.size(contentBg:getContentSize().width - 2 * 10, contentBg:getContentSize().height - 2 * 20)):addTo(contentBg)
	pageView:setPosition(10, 20)
	pageView:reloadData()
	self.m_pageView = pageView

	local function scrollPage(event)
		local curPage = pageView:getCurrentIndex()
		if curPage <= 1 then
			lastBtn:setVisible(false)
		else
			lastBtn:setVisible(true)
		end

		if curPage >= pageView:numberOfCells() then
			nxtBtn:setVisible(false)
		else
			nxtBtn:setVisible(true)
		end

		self.m_vipLabel:setString(string.format(CommonText[408], curPage))
	end

	pageView:addEventListener("PAGE_SCROLL_TO", scrollPage)

	local pageIndex = UserMO.vip_ + 1

	if pageIndex > VipMO.queryMaxVip() then pageIndex = VipMO.queryMaxVip() end
	pageView:setCurrentIndex(pageIndex)

	-- --尊享VIP按钮
	-- local normal = display.newSprite(IMAGE_COMMON .. "btn_9_normal.png")
	-- local selected = display.newSprite(IMAGE_COMMON .. "btn_9_selected.png")
	-- local vip6Btn = MenuButton.new(normal, selected, nil, handler(self, self.onVip6ServCallback)):addTo(self:getBg())
	-- vip6Btn:setLabel(CommonText[846],{color = COLOR[12]})
	-- vip6Btn:setPosition(self:getBg():getContentSize().width / 2, self:getBg():getContentSize().height - 920)
	-- vip6Btn:setVisible(UserMO.vip_ >= PERSONAL_SERVICE_VIP)
end

function VipView:onChargeCallback(tag, sender)
	ManagerSound.playNormalButtonSound()
	self:pop()
	require("app.view.RechargeView").new():push()
end

function VipView:onLastCallback(tag, sender)
	ManagerSound.playNormalButtonSound()

	local curPage = self.m_pageView:getCurrentIndex()
	self.m_pageView:setCurrentIndex(curPage - 1, true)
end

function VipView:onNextCallback(tag, sender)
	ManagerSound.playNormalButtonSound()

	local curPage = self.m_pageView:getCurrentIndex()
	self.m_pageView:setCurrentIndex(curPage + 1, true)
end

-- function VipView:onVip6ServCallback(tag, sender)
-- 	ManagerSound.playNormalButtonSound()
-- 	require("app.dialog.VipServiceDialog").new():push()
-- end

return VipView